SystemOrganization addCategory: #Smagick!
SystemOrganization addCategory: #'Smagick-Drawing'!
SystemOrganization addCategory: #'Smagick-Globals'!
SystemOrganization addCategory: #'Smagick-Tests'!
SystemOrganization addCategory: #'Smagick-Utils'!

!String methodsFor: '*Smagick' stamp: 'SR 6/30/2007 18:20'!
asGeometry
	^ self! !

!String methodsFor: '*Smagick' stamp: 'SR 8/4/2007 11:51'!
asSmagickImage
	^ SmagickImage on: self! !

!String methodsFor: '*Smagick' stamp: 'SR 8/27/2007 10:31'!
asSmagickTile
	^ self , ':'! !

Set subclass: #SmagickFontFamily
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Utils'!

!SmagickFontFamily methodsFor: 'accessing' stamp: 'SR 9/1/2007 13:57'!
fonts
	^ self asArray! !

!SmagickFontFamily methodsFor: 'accessing' stamp: 'SR 9/1/2007 13:57'!
name
	^ self fonts anyOne name! !

!SmagickFontFamily methodsFor: 'printing' stamp: 'SR 9/1/2007 13:58'!
printOn: aStream
	aStream nextPutAll: self name! !

!Point methodsFor: '*Smagick' stamp: 'SR 8/11/2007 20:07'!
asArray
	^ Array with: self x with: self y! !

!Point methodsFor: '*Smagick' stamp: 'nl 1/16/2008 15:47'!
asCoordinate
	^ (self x isNil not and: [ self x isNil not ])
		ifTrue: [ self x asString, ',', self y asString ]
		ifFalse: [ '' ]! !

!Point methodsFor: '*Smagick' stamp: 'SR 6/30/2007 17:44'!
asGeometry
	(self x isNil and: [ self y isNil ]) ifTrue: [ ^ '0x0' ].
	^ (self x ifNil: [ '' ]) asString, 'x', (self y ifNil: [ '' ]) asString! !

!Magnitude methodsFor: '*Smagick' stamp: 'SR 6/30/2007 18:17'!
asGeometry
	^ self! !

!Stream methodsFor: '*Smagick' stamp: 'SR 8/25/2007 12:36'!
comma
	self nextPut: Character comma! !

!Stream methodsFor: '*Smagick' stamp: 'SR 8/25/2007 12:37'!
semicolon
	self nextPut: Character semicolon! !

!Collection methodsFor: '*Smagick-private' stamp: 'SR 9/9/2007 14:31'!
asSmagickImages
	^ self asSmagickImagesOn: Error do: [ :exception :image | exception signal: image asString ]! !

!Collection methodsFor: '*Smagick-private' stamp: 'SR 9/9/2007 14:14'!
asSmagickImagesOn: anExceptionClass do: aBlock
	^ self collect: [ :each | [ each asSmagickImage ]
		on: anExceptionClass 
		do: [ :e | aBlock value: e value: each ] ]. ! !

!Collection methodsFor: '*Smagick' stamp: 'SR 9/9/2007 14:31'!
smagickCollect: aBlock
	^ self smagickCollect: aBlock on: Error do: [ :exception :image | exception signal: image asString ]! !

!Collection methodsFor: '*Smagick' stamp: 'SR 9/9/2007 14:17'!
smagickCollect: aBlock on: anExceptionClass do: anotherBlock
	^ (self asSmagickImagesOn: anExceptionClass do: anotherBlock) 
		collect: [ :each | [ aBlock value: each ] 
			on: anExceptionClass 
			do: [ :e | anotherBlock value: e value: each ] ]! !

!Collection methodsFor: '*Smagick' stamp: 'SR 9/9/2007 14:31'!
smagickConvertTo: block1 with: block2
	^ self smagickConvertTo: block1 with: block2 on: Error do: [ :exception :image | exception signal: image asString ]! !

!Collection methodsFor: '*Smagick' stamp: 'SR 9/9/2007 14:43'!
smagickConvertTo: aBlock1 with: aBlock2 on: anExceptionClass do: aBlock3
	^ (self asSmagickImagesOn: anExceptionClass do: [ :e :i | aBlock3 value: e value: i ])
		smagickCollect: [ :image | image 
									convertTo: (aBlock1 value: image) 
									with: [ :converter | aBlock2 value: converter ] ] 
		on: anExceptionClass 
		do: [ :e :i | aBlock3 value: e value: i ]! !

!Collection methodsFor: '*Smagick' stamp: 'SR 9/9/2007 13:54'!
smagickDo: aBlock
	self smagickCollect: aBlock! !

!Collection methodsFor: '*Smagick' stamp: 'SR 9/9/2007 13:55'!
smagickDo: aBlock on: anExceptionClass do: anotherBlock
	^ self smagickCollect: aBlock on: anExceptionClass do: anotherBlock! !

!Collection methodsFor: '*Smagick' stamp: 'SR 9/9/2007 13:55'!
smagickSelect: aBlock
	^ (self smagickCollect: aBlock) select: [ :each | aBlock value: each ]! !

!Collection methodsFor: '*Smagick' stamp: 'SR 9/9/2007 13:56'!
smagickSelect: aBlock on: anExceptionClass do: anotherBlock
	^ (self smagickCollect: aBlock on: anExceptionClass do: anotherBlock)
		select: [ :each | aBlock value: each ]! !

TestCase subclass: #SmagickTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Tests'!

SmagickTest subclass: #SmagickImagingTest
	instanceVariableNames: 'images'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Tests'!

!SmagickImagingTest methodsFor: 'private' stamp: 'SR 8/22/2007 23:02'!
images
	^ images ifNil: [ images := OrderedCollection new ]! !

!SmagickImagingTest methodsFor: 'private' stamp: 'SR 8/22/2007 23:06'!
localImage: aString do: aBlock
	| url |
	url := self localUrlFor: aString.
	[ self images add: url ] 
		ensure: [ aBlock value: url ]! !

!SmagickImagingTest methodsFor: 'private' stamp: 'SR 8/22/2007 23:07'!
localUrlFor: aString
	^ FileDirectory default fullName, FileDirectory pathNameDelimiter asString, aString ! !

!SmagickImagingTest methodsFor: 'fixtures' stamp: 'SR 8/22/2007 23:27'!
logo: aString
	^ SmagickLogo on: aString! !

!SmagickImagingTest methodsFor: 'fixtures' stamp: 'SR 8/22/2007 23:25'!
logo: aString do: aBlock
	^ aBlock value: (self logo: aString)! !

!SmagickImagingTest methodsFor: 'setup' stamp: 'SR 9/1/2007 13:12'!
tearDown
	self images do: [ :each |
		FileDirectory deleteFilePath: each.
		self assert: (StandardFileStream isAFileNamed: each) not ]! !

!SmagickImagingTest methodsFor: 'tests' stamp: 'SR 8/23/2007 00:04'!
testLogoComposition
	self shouldnt: [ 
			self localImage: 'logo1.png' do: [ :i1 |
				self localImage: 'logo2.png' do: [ :i2 | 
					self localImage: 'logo3.jpg' do: [ :out |
						(self logo: i1) 
							composeWith: (self logo: i2)
							to: out
							using: #colorBurn ] ] ] ]
		raise: Error! !

!SmagickImagingTest methodsFor: 'tests' stamp: 'SR 8/22/2007 23:31'!
testLogoConversion
	self shouldnt: [ 
			self localImage: 'logo.png' do: [ :from |
				self logo: from do: [ :logo |
					self localImage: 'logo.bmp' do: [ :to |
						logo convertTo: to ] ] ] ] 
		raise: Error! !

!SmagickImagingTest methodsFor: 'tests' stamp: 'SR 8/22/2007 23:35'!
testLogoConversionWithSomeTransformations
	self shouldnt: [ 
			self localImage: 'logo.png' do: [ :from |
				self logo: from do: [ :logo |
					self localImage: 'logo.bmp' do: [ :to |
						logo convertTo: to with: [ :conv |
							conv antialias; negate; sepia: 5; quality: 0; enhance; normalize ] ] ] ] ] 
		raise: Error! !

!SmagickImagingTest methodsFor: 'tests' stamp: 'SR 8/22/2007 23:31'!
testLogoCreation
	self shouldnt: [ 
			self localImage: 'logo' do: [ :file | self logo: file ] ] 
		raise: Error.! !

!SmagickImagingTest methodsFor: 'tests' stamp: 'SR 9/1/2007 14:08'!
testLogoDrawing
	self shouldnt: [ 
			self localImage: 'logo.png' do: [ :from |
				self logo: from do: [ :logo |
					logo with: [ :canvas | canvas
						lineFrom: 0@0 to: 1@1 ] ] ] ] 
		raise: Error! !

!SmagickImagingTest methodsFor: 'tests' stamp: 'SR 8/22/2007 23:27'!
testLogoInfo
	self shouldnt: [ 
			self localImage: 'logo.png' do: [ :file |
				self logo: file do: [ :logo | 
					self assert: logo properties isEmpty not ] ] ]
		raise: Error! !

SmagickTest subclass: #SmagickPerformanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Tests'!

!SmagickPerformanceTest methodsFor: 'as yet unclassified' stamp: 'SR 9/1/2007 14:19'!
testSmagickPerformance
	" we takte the command modules request as an example < 1sec "
	| block |
	block := [ self environment modules ].
	self assert: ((1 to: 10) inject: 0 into: [ :sum :each | sum + block timeToRun ]) / 10 < 2000.! !

!SmagickPerformanceTest methodsFor: 'as yet unclassified' stamp: 'SR 9/1/2007 14:19'!
testSmagickUnderStress
	1 to: 10 do: [ :each |
		self shouldntRaiseError: [ self environment modules ]. ]! !

!SmagickTest methodsFor: 'assertions' stamp: 'SR 8/3/2007 16:52'!
assertGeometry: aString is: aCollection
	| instance instance2 |
	instance := SmagickGeometry new
			width: aCollection first;
			height: aCollection second;
			xoffset: aCollection third;
			yoffset: aCollection fourth;
			yourself.
	instance perform: aCollection fifth.
	instance2 := SmagickGeometry from: aString.
	self assert: instance2 = instance.! !

!SmagickTest methodsFor: 'private' stamp: 'SR 8/5/2007 11:08'!
enhancedFormats
	^ #(pdf eps ps tiff psd raw)! !

!SmagickTest methodsFor: 'accessing' stamp: 'SR 8/3/2007 16:40'!
environment
	^ SmagickEnvironment default! !

!SmagickTest methodsFor: 'private' stamp: 'SR 8/5/2007 11:03'!
minimalFormats
	^ #(png jpg gif bmp pdf)! !

!SmagickTest methodsFor: 'fixtures' stamp: 'SR 8/3/2007 18:10'!
reset
	FileDirectory default entries 
		do: [ :each |
			('*smagick*' match: each name) 
				ifTrue: [ FileDirectory default deleteFileNamed: each name ] ]! !

!SmagickTest methodsFor: 'fixtures' stamp: 'SR 8/3/2007 18:05'!
setUp
	self reset! !

!SmagickTest methodsFor: 'assertions' stamp: 'SR 8/3/2007 16:52'!
shouldFailGeometry: aString
	self  should: [ SmagickGeometry from: aString ] raise: SmagickInvalidGeometry ! !

!SmagickTest methodsFor: 'assertions' stamp: 'SR 8/3/2007 17:38'!
shouldntRaiseError: aBlock
	self shouldnt: aBlock raise: Error! !

!SmagickTest methodsFor: 'fixtures' stamp: 'SR 8/3/2007 18:05'!
tearDown
	self reset! !

!SmagickTest methodsFor: 'tests smagickability' stamp: 'SR 8/5/2007 11:04'!
testEnhancedEnvironment
	" an enhanced system should support those formats "
	self assert: (self environment canWriteAll: self minimalFormats, self enhancedFormats)! !

!SmagickTest methodsFor: 'tests smagickability' stamp: 'SR 9/1/2007 14:18'!
testFontFamillies
	| families |
	self shouldnt: [ families := self environment fontFamilies ] raise: Error.
	self deny: families isEmpty! !

!SmagickTest methodsFor: 'tests smagickability' stamp: 'SR 9/1/2007 14:18'!
testFonts
	| fonts |
	self shouldnt: [ fonts := self environment fonts ] raise: Error.
	self deny: fonts isEmpty! !

!SmagickTest methodsFor: 'tests' stamp: 'SR 8/3/2007 16:57'!
testGeometry
	self assertGeometry: '4x5' is: { 4. 5. 0. 0. #beNormal }.
	self assertGeometry: '4x5!!' is: { 4. 5. 0. 0. #beExactly }.
	self assertGeometry: '4x5%' is: { 4. 5. 0. 0. #bePercentage }.
	self assertGeometry: '4x5>' is: { 4. 5. 0. 0. #resizeIfGreater }.
	self assertGeometry: '4x5<' is: { 4. 5. 0. 0. #resizeIfSmaller }.! !

!SmagickTest methodsFor: 'tests' stamp: 'SR 8/3/2007 17:34'!
testGeometryFail
	self shouldFailGeometry: '4x'.
	self shouldFailGeometry: '4x5+4'.
	self shouldFailGeometry: '4x5+4x9'.
	self shouldFailGeometry: '4x5x4x9'.
	self shouldFailGeometry: '4x5+4+9?'.
	self shouldFailGeometry: '4X5*4+9!!'.
	self shouldFailGeometry: '4y5'.
	self shouldFailGeometry: '4x5+4*9'.
	self shouldFailGeometry: '4x5+4+9_'.! !

!SmagickTest methodsFor: 'tests' stamp: 'SR 8/3/2007 16:57'!
testGeometryFull
	self assertGeometry: '4x5+4+5' is: { 4. 5. 4. 5. #beNormal }.
	self assertGeometry: '4x5-4-5!!' is: { 4. 5. -4. -5. #beExactly }.
	self assertGeometry: '4x5+4-5%' is: { 4. 5. 4. -5. #bePercentage }.
	self assertGeometry: '4x5-4+5>' is: { 4. 5. -4. 5. #resizeIfGreater }.
	self assertGeometry: '4x5+4+5<' is: { 4. 5. 4. 5. #resizeIfSmaller }.! !

!SmagickTest methodsFor: 'tests smagickability' stamp: 'SR 9/1/2007 14:19'!
testHealthyEnvironment
	" we must hae at least two ormats with read and write capabilities - otherwise imaging is useless "
	| modules |
	modules := self environment modules.
	self assert: (modules select: [ :each | each canRead and: [ each canWrite ] ]) size >= 2! !

!SmagickTest methodsFor: 'tests smagickability' stamp: 'SR 8/5/2007 11:10'!
testInstallation
	self shouldnt: [ SmagickEnvironment default ] raise: Error.
	self assert: self environment installationPath isNil not.
	self assert: (self environment class validate: self environment installationPath)! !

!SmagickTest methodsFor: 'tests smagickability' stamp: 'SR 8/5/2007 11:01'!
testMinimalEnvironment
	" a minimal system should support those formats "
	self assert: (self environment canWriteAll: #(png jpg gif bmp pdf))! !

!SmagickTest methodsFor: 'tests smagickability' stamp: 'SR 9/1/2007 14:22'!
testRuntime
	self shouldntRaiseError: [ self environment modules ].
	self shouldntRaiseError: [ self environment supportsAll: #(png jpg) ].
	self shouldntRaiseError: [ self environment supportedFormats: #(png jpg) ].
	self shouldntRaiseError: [ self environment unsupportedFormats: #(png jpg) ].
	self shouldntRaiseError: [ self environment canRead: 'png' ].
	self shouldntRaiseError: [ self environment canWrite: 'png' ].
	self shouldntRaiseError: [ self environment supports: 'png' ].! !

OrderedCollection subclass: #SmagickCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Utils'!

!SmagickCollection methodsFor: 'printing' stamp: 'SR 9/1/2007 14:00'!
printOn: aStream
	self do: [ :each | each printOn: aStream ] separatedBy: [ aStream cr ]! !

OrderedCollection subclass: #SmagickFormatProperties
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Utils'!

!SmagickFormatProperties methodsFor: 'private' stamp: 'SR 7/12/2007 23:38'!
formatDelimiter
	^ Character comma! !

!SmagickFormatProperties methodsFor: 'private' stamp: 'SR 7/12/2007 23:40'!
parse: aStream
	^ aStream asString subStrings: self formatDelimiter asString! !

!SmagickFormatProperties methodsFor: 'printing' stamp: 'SR 7/12/2007 23:41'!
printOn: aStream
	self isEmpty ifFalse: [ 
		aStream nextPutAll: self symbol; space; nextPutAll: '"'.
		self do: [ :each | each printOn: aStream ] separatedBy: [ aStream nextPut: self formatDelimiter; space ].
		aStream nextPutAll: '"' ]! !

!SmagickFormatProperties methodsFor: 'accessing' stamp: 'SR 7/12/2007 23:37'!
symbol
	^ '-format'! !

Object subclass: #Smagick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick'!

!Smagick class methodsFor: 'internal-primitives' stamp: 'SR 12/17/2007 12:20'!
animate: aCollection to: aFile
	^ self animator new
		images: aCollection;
		to: aFile! !

!Smagick class methodsFor: 'accessing-tools' stamp: 'SR 2/12/2008 16:14'!
animationConverter
	^ SmagickAnimationConvert! !

!Smagick class methodsFor: 'accessing-tools' stamp: 'SR 2/12/2008 16:13'!
animator
	^ SmagickAnimation! !

!Smagick class methodsFor: 'internal-primitives' stamp: 'SR 8/23/2007 00:06'!
compose: aFile from: aCollection using: anOperator
	^ self composer new
		to: aFile;
		apply: anOperator withAll: aCollection;
		yourself! !

!Smagick class methodsFor: 'accessing-tools' stamp: 'SR 8/10/2007 23:10'!
composer
	^ SmagickCompose! !

!Smagick class methodsFor: 'internal-primitives' stamp: 'SR 8/10/2007 21:06'!
convert: aFile to: anotherFile
	^ self converter new
		from: aFile;
		to: anotherFile;
		yourself! !

!Smagick class methodsFor: 'accessing-tools' stamp: 'SR 8/10/2007 21:05'!
converter
	^ SmagickConvert! !

!Smagick class methodsFor: 'accessing-tools' stamp: 'SR 8/10/2007 23:20'!
difference
	^ SmagickCompare! !

!Smagick class methodsFor: 'internal-primitives' stamp: 'SR 8/10/2007 23:24'!
differenceBetween: aFile and: anotherFile to: yetAnotherFile
	^ (self difference new)
		from: aFile;
		to: anotherFile;
		difference: yetAnotherFile;
		yourself! !

!Smagick class methodsFor: 'accessing-tools' stamp: 'SR 8/10/2007 21:05'!
identifier
	^ SmagickIdentify! !

!Smagick class methodsFor: 'internal-primitives' stamp: 'SR 8/10/2007 21:06'!
identify: aFile
	^ self identifier new 
		from: aFile;
		yourself! !

!Smagick class methodsFor: 'accessing-tools' stamp: 'SR 8/10/2007 21:05'!
image
	^ SmagickImage! !

!Smagick class methodsFor: 'accessing-tools' stamp: 'SR 8/10/2007 21:05'!
logo
	^ SmagickLogo! !

!Smagick class methodsFor: 'internal-primitives' stamp: 'SR 8/10/2007 21:06'!
logo: aFile
	^ self logo new
		to: aFile;
		yourself! !

!Smagick class methodsFor: 'internal-primitives' stamp: 'SR 8/10/2007 21:06'!
on: aFile
	^ self image on: aFile! !

!Smagick class methodsFor: 'internal-primitives' stamp: 'SR 8/11/2007 00:31'!
on: aFile with: aDictionary
	^ self image on: aFile with: aDictionary! !

!Smagick methodsFor: 'converting' stamp: 'SR 8/10/2007 21:02'!
asSmagickImage
	^ self subclassResponsibility! !

!Smagick methodsFor: 'private' stamp: 'SR 5/8/2008 11:17'!
assertFileExistence: aFile
	(aFile notNil and: [ self environment streamClass isAFileNamed: aFile ]) 
		ifFalse: [ SmagickFileDoesNotExist signal ]! !

!Smagick methodsFor: 'actions' stamp: 'SR 8/10/2007 21:20'!
composeWith: aFile to: anotherFile using: anOperator 
	^ self composeWithAll: (Array with: aFile) to: anotherFile using: anOperator ! !

!Smagick methodsFor: 'actions' stamp: 'SR 8/10/2007 21:19'!
composeWithAll: aCollection to: anotherFile using: anOperator 
	^ self imageDo: [ :image | image composeWithAll: aCollection to: anotherFile using: anOperator ] ! !

!Smagick methodsFor: 'actions' stamp: 'SR 8/10/2007 21:01'!
convertTo: aFile
	^ self convertTo: aFile with:  [ :converter | " convert only " ]! !

!Smagick methodsFor: 'actions' stamp: 'SR 8/10/2007 21:14'!
convertTo: aFile with: aBlock
	^ self imageDo: [ :image | image convertTo: aFile with: aBlock ] ! !

!Smagick methodsFor: 'actions' stamp: 'SR 8/10/2007 23:19'!
difference: aFile to: anotherFile
	^ self imageDo: [ :image | image difference: aFile to: anotherFile ]! !

!Smagick methodsFor: 'accessing' stamp: 'SR 8/10/2007 21:03'!
environment
	^ SmagickEnvironment default! !

!Smagick methodsFor: 'private' stamp: 'SR 8/10/2007 21:16'!
exceptionClass
	^ SmagickException! !

!Smagick methodsFor: 'actions' stamp: 'SR 8/10/2007 21:33'!
identify
	^ self imageDo: [ :image | image properties; yourself ] ! !

!Smagick methodsFor: 'private' stamp: 'SR 8/10/2007 21:13'!
imageDo: aBlock
	^ self imageDo: aBlock else: [ :exception | exception signal ]! !

!Smagick methodsFor: 'private' stamp: 'SR 8/10/2007 21:12'!
imageDo: aBlock else: anotherBlock
	^ self asSmagickImage
		ifNotNilDo: [ :image | aBlock value: image ]
		ifNil: [ anotherBlock value: self exceptionClass ]! !

!Smagick methodsFor: 'printing' stamp: 'SR 8/10/2007 21:02'!
printOn: aStream
	self subclassResponsibility! !

!Smagick methodsFor: 'accessing' stamp: 'SR 9/7/2007 18:27'!
smagick
	^ self environment root! !

!Smagick methodsFor: 'accessing' stamp: 'SR 9/9/2007 14:39'!
streamClass
	^ self environment streamClass! !

!Smagick methodsFor: 'actions' stamp: 'SR 8/26/2007 16:24'!
with: aBlock
	^ self with: aBlock to: self file! !

!Smagick methodsFor: 'actions' stamp: 'SR 8/26/2007 16:24'!
with: aBlock to: aFile
	^ self 
		convertTo: aFile
		with: [ :converter | converter with: aBlock ]! !

Smagick subclass: #SmagickImage
	instanceVariableNames: 'file properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick'!

!SmagickImage class methodsFor: 'instance creation' stamp: 'SR 7/12/2007 18:46'!
on: aFile
	^ self new
		file: aFile;
		yourself! !

!SmagickImage class methodsFor: 'instance creation' stamp: 'SR 8/11/2007 00:29'!
on: aFile with: aDictionary
	^ self new 
		file: aFile with: aDictionary; 
		yourself! !

!SmagickImage methodsFor: 'actions' stamp: 'SR 12/17/2007 13:48'!
animateWith: anImage to: anotherFile using: aBlock
	^ self animateWithAll: (Array with: anImage) to: anotherFile using: aBlock ! !

!SmagickImage methodsFor: 'actions' stamp: 'SR 2/12/2008 16:13'!
animateWithAll: aCollection to: anotherFile using: aBlock 
	^ SmagickAnimation
		animate: (OrderedCollection new
			add: self file;
			addAll: (aCollection collect: [ :each | each file ]);
			yourself)
		to: anotherFile
		with: aBlock! !

!SmagickImage methodsFor: 'converting' stamp: 'SR 8/10/2007 20:57'!
asSmagickImage
	^ self! !

!SmagickImage methodsFor: 'converting' stamp: 'SR 7/12/2007 18:46'!
asString
	^ self file asString! !

!SmagickImage methodsFor: 'private' stamp: 'SR 2/13/2008 13:40'!
at: aSymbol
	^ self properties 
		at: aSymbol 
		ifAbsentPut: [ self gather: aSymbol ifAbsent: [ nil ] ]! !

!SmagickImage methodsFor: 'private' stamp: 'vnc 2/12/2008 09:36'!
basicMimeType
	| processor |
	processor := OSProcessParsedRawIO new
		command: 'file --mime "', self file, '"';
		parser: [ :process | | prefix prefixIndex |
			prefix := self file, ':'.
			prefixIndex := process outputString indexOfSubCollection: prefix.
			prefixIndex = 0 ifTrue: [ ^ '' ].
			(process outputString 
				copyFrom: ((prefixIndex + prefix size) min: process outputString size)
				to: process outputString size) withBlanksTrimmed ];
		yourself.
	^ processor result! !

!SmagickImage methodsFor: 'image properties' stamp: 'SR 8/4/2007 08:30'!
boundingBox
	^ self at: #boundingBox! !

!SmagickImage methodsFor: 'actions' stamp: 'SR 8/23/2007 00:08'!
composeWith: aFile to: anotherFile using: anOperator
	^ self composeWithAll: (Array with: aFile file) to: anotherFile using: anOperator! !

!SmagickImage methodsFor: 'actions' stamp: 'SR 8/10/2007 23:27'!
composeWithAll: aCollection to: anotherFile using: anOperator
	^ self smagick 
		compose: anotherFile 
		from: ((Array with: self file), aCollection) 
		using: anOperator! !

!SmagickImage methodsFor: 'image properties' stamp: 'SR 7/12/2007 21:13'!
compressionQualty
	^ self at: #compressionQualty! !

!SmagickImage methodsFor: 'image properties' stamp: 'SR 7/12/2007 21:13'!
compressionType
	^ self at: #compressionType! !

!SmagickImage methodsFor: 'actions' stamp: 'SR 11/22/2007 18:50'!
convertTo: aFile with: aBlock
	^ self 
		imageAt: nil 
		convertTo: aFile 
		with: aBlock! !

!SmagickImage methodsFor: 'private-accessing' stamp: 'SR 2/12/2008 16:14'!
converterFor: aFile
	^ (self isAnimation and: [ self isAnimation: aFile ])
		ifTrue: [ self class animationConverter ]
		ifFalse: [ self class converter ]! !

!SmagickImage methodsFor: 'morph compatibility' stamp: 'SR 8/2/2007 12:23'!
depth
	^ self quantumDepth ! !

!SmagickImage methodsFor: 'actions' stamp: 'SR 8/10/2007 23:23'!
difference: aFile to: anotherFile
	^ (self smagick differenceBetween: self file and: aFile to: anotherFile) result! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:55'!
exifApertureValue
	^ self at: #exifApertureValue! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:48'!
exifArtist
	^ self at: #exifArtist! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:16'!
exifBatteryLevel
	^ self at: #exifBatteryLevel! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:48'!
exifBitsPerSample
	^ self at: #exifBitsPerSample! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:56'!
exifBrightnessValue
	^ self at: #exifBrightnessValue! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:16'!
exifCFAPattern
	^ self at: #exifCFAPattern! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:16'!
exifCFARepeatPatternDim
	^ self at: #exifCFARepeatPatternDim! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:17'!
exifComponentsConfiguration
	^ self at: #exifComponentsConfiguration! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:18'!
exifCompressedBitsPerPixel
	^ self at: #exifCompressedBitsPerPixel! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:53'!
exifCopyright
	^ self at: #exifCopyright! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:48'!
exifDateTime
	^ self at: #exifDateTime! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:54'!
exifExifVersion
	^ self at: #exifExifVersion! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:56'!
exifExposureBiasValue
	^ self at: #exifExposureBiasValue! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:19'!
exifExposureIndex
	^ self at: #exifExposureIndex! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:17'!
exifExposureProgram
	^ self at: #exifExposureProgram! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:53'!
exifExposureTime
	^ self at: #exifExposureTime! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:17'!
exifFNumber
	^ self at: #exifFNumber! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:13'!
exifFillOrder
	^ self at: #exifFillOrder! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:56'!
exifFlash
	^ self at: #exifFlash! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:58'!
exifFlashEnergy
	^ self at: #exifFlashEnergy! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:56'!
exifFocalLength
	^ self at: #exifFocalLength! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:54'!
exifGPSInfo
	^ self at: #exifGPSInfo! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:54'!
exifISOSpeedRatings
	^ self at: #exifISOSpeedRatings! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:48'!
exifImageDescription
	^ self at: #exifImageDescription! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:17'!
exifInterColorProfile
	^ self at: #exifInterColorProfile! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:52'!
exifJPEGInterchangeFormat
	^ self at: #exifJPEGInterchangeFormat! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:53'!
exifJPEGInterchangeFormatLength
	^ self at: #exifJPEGInterchangeFormatLength! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:15'!
exifJPEGProc
	^ self at: #exifJPEGProc! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:18'!
exifLightSource
	^ self at: #exifLightSource! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:59'!
exifMaxApertureValue
	^ self at: #exifMaxApertureValue! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:57'!
exifMeteringMode
	^ self at: #exifMeteringMode! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:13'!
exifModel
	^ self at: #exifModel! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:48'!
exifOrientation
	^ self at: #exifOrientation! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:12'!
exifPhotometricInterpretation
	^ self at: #exifPhotometricInterpretation! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:13'!
exifPlanarConfiguration
	^ self at: #exifPlanarConfiguration! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:14'!
exifPrimaryChromaticities
	^ self at: #exifPrimaryChromaticities! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:16'!
exifReferenceBlackWhite
	^ self at: #exifReferenceBlackWhite! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:13'!
exifResolutionUnit
	^ self at: #exifResolutionUnit! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:48'!
exifSamplesPerPixel
	^ self at: #exifSamplesPerPixel! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:58'!
exifSceneType
	^ self at: #exifSceneType! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:58'!
exifSensingMethod
	^ self at: #exifSensingMethod! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:55'!
exifShutterSpeedValue
	^ self at: #exifShutterSpeedValue! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:14'!
exifSoftware
	^ self at: #exifSoftware! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:53'!
exifSpectralSensitivity
	^ self at: #exifSpectralSensitivity! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:57'!
exifSubjectDistance
	^ self at: #exifSubjectDistance! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:19'!
exifSubjectLocation
	^ self at: #exifSubjectLocation! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:14'!
exifTransferFunction
	^ self at: #exifTransferFunction! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:14'!
exifTransferRange
	^ self at: #exifTransferRange! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:57'!
exifUserComment
	^ self at: #exifUserComment! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:49'!
exifWhitePoint
	^ self at: #exifWhitePoint! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:15'!
exifYCbCrCoefficients
	^ self at: #exifYCbCrCoefficients! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:15'!
exifYCbCrPositioning
	^ self at: #exifYCbCrPositioning! !

!SmagickImage methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:15'!
exifYCbCrSubSampling
	^ self at: #exifYCbCrSubSampling! !

!SmagickImage methodsFor: 'morph compatibility' stamp: 'SR 8/2/2007 13:05'!
extent
	^ self width @ self height! !

!SmagickImage methodsFor: 'accessing' stamp: 'SR 7/12/2007 18:41'!
file
	^ file! !

!SmagickImage methodsFor: 'accessing' stamp: 'SR 7/14/2007 18:06'!
file: aFile
	self assertFileExistence: aFile.
	file := aFile! !

!SmagickImage methodsFor: 'accessing' stamp: 'SR 9/7/2007 18:25'!
file: aFile with: aDictionary
	" be carefull using this accessor. aDictionary keeps the properties of this file "
	self file: aFile.
	properties := aDictionary! !

!SmagickImage methodsFor: 'accessing-dynamic' stamp: 'SR 9/9/2007 14:42'!
fileExtension
	" self at: #fileExtension "
	^ self file copyAfterLast: $.! !

!SmagickImage methodsFor: 'accessing-dynamic' stamp: 'SR 9/9/2007 14:38'!
fileName
	" self at: #fileName "
	^ self file copyUpToLast: $.! !

!SmagickImage methodsFor: 'image properties' stamp: 'SR 9/3/2007 18:43'!
fileSize
	^ (StandardFileStream fileNamed: self file) size! !

!SmagickImage methodsFor: 'morph compatibility' stamp: 'SR 8/4/2007 08:30'!
form
	^ self boundingBox asForm! !

!SmagickImage methodsFor: 'private' stamp: 'SR 8/26/2007 09:19'!
gather: aSymbol ifAbsent: aBlock
	| instance |
	instance := self environment root identify: self file.
	^ (instance perform: aSymbol) execute result 
		at: aSymbol 
		ifAbsent: aBlock! !

!SmagickImage methodsFor: 'image properties' stamp: 'SR 8/4/2007 08:27'!
geometry
	^ self at: #boundingBox! !

!SmagickImage methodsFor: 'image properties' stamp: 'SR 7/12/2007 20:40'!
height
	^ self at: #height! !

!SmagickImage methodsFor: 'private' stamp: 'SR 11/22/2007 19:04'!
imageAt: anInteger
	" this will return the im-url of the nth image in self file, 0 otherwise "
	" as we are in smalltalk we expect 1 to be the first image - im will not throw an exception if anINtger is larger than images contained by self "
	anInteger ifNil: [ ^ self file ].
	^ String streamContents: [ :stream | stream
		nextPutAll: self file;
		nextPut: $[;
		nextPutAll: (anInteger isNumber ifTrue: [ ((anInteger - 1) max: 0) ] ifFalse: [ 0 ]) asString;
		nextPut: $] ]! !

!SmagickImage methodsFor: 'actions' stamp: 'SR 11/22/2007 18:56'!
imageAt: anInteger convertTo: aFile
	^ self imageAt: anInteger convertTo: aFile with: [ :converter | ]! !

!SmagickImage methodsFor: 'actions' stamp: 'SR 2/12/2008 16:00'!
imageAt: anInteger convertTo: aFile with: aBlock
	| converter |
	converter := (self converterFor: aFile) new
		from: (self imageAt: anInteger);
		to: aFile;
		yourself.
	aBlock value: converter.
	^ converter result! !

!SmagickImage methodsFor: 'image properties' stamp: 'SR 7/14/2007 12:42'!
imageClassAndColorspace
	^ self at: #imageClassAndColorspace! !

!SmagickImage methodsFor: 'image properties' stamp: 'SR 7/14/2007 12:48'!
imageDelay
	^ self at: #imageDelay! !

!SmagickImage methodsFor: 'image properties' stamp: 'SR 7/14/2007 12:43'!
imageName
	^ self at: #imageName! !

!SmagickImage methodsFor: 'testing' stamp: 'SR 2/12/2008 15:37'!
isAnimation
	^ self isAnimation: self file! !

!SmagickImage methodsFor: 'private' stamp: 'SR 2/12/2008 15:56'!
isAnimation: aString
	^ aString size <= 4 
		ifTrue: [ false ]
		ifFalse: [ (aString last: 4) includesSubstring: '.gif' caseSensitive: false ]! !

!SmagickImage methodsFor: 'testing' stamp: 'vnc 2/12/2008 09:47'!
isSmagickImage
	[ self identify ] 
		on: SmagickTransformationException 
		do: [ ^ false ].
	^ true! !

!SmagickImage methodsFor: 'private' stamp: 'SR 7/15/2007 18:05'!
loadProperties
	| instance |
	instance := self environment root identify: self file.
	self propertiesSelectors
		do: [ :each | instance perform: each ].
	^ instance execute result! !

!SmagickImage methodsFor: 'image properties' stamp: 'SR 7/14/2007 12:41'!
magick
	^ self at: #magick! !

!SmagickImage methodsFor: 'image properties' stamp: 'vnc 2/12/2008 09:22'!
mimeType
	self properties 
		at: #mimeType
		ifAbsentPut: [ self basicMimeType ]! !

!SmagickImage methodsFor: 'image properties' stamp: 'vnc 2/12/2008 09:22'!
mimeType: aString
	self properties 
		at: #mimeType
		put: aString! !

!SmagickImage methodsFor: 'image properties' stamp: 'SR 7/14/2007 13:05'!
pageDimension
	^ self pageWidth @ self pageHeight! !

!SmagickImage methodsFor: 'image properties' stamp: 'SR 7/15/2007 18:17'!
pageGeometry
	^ self pageDimension -> self pageOffset! !

!SmagickImage methodsFor: 'image properties' stamp: 'SR 7/14/2007 12:46'!
pageHeight
	^ self at: #pageHeight! !

!SmagickImage methodsFor: 'image properties' stamp: 'SR 7/14/2007 12:41'!
pageNumber
	^ self at: #pageNumber! !

!SmagickImage methodsFor: 'image properties' stamp: 'SR 7/14/2007 12:44'!
pageOffset
	^ self at: #pageOffset! !

!SmagickImage methodsFor: 'image properties' stamp: 'SR 7/14/2007 12:46'!
pageWidth
	^ self at: #pageWidth! !

!SmagickImage methodsFor: 'image properties' stamp: 'SR 9/3/2007 18:41'!
primFileSize
	^ (StandardFileStream fileNamed: self file) size! !

!SmagickImage methodsFor: 'printing' stamp: 'SR 8/10/2007 21:26'!
printOn: aStream
	aStream nextPutAll: self file! !

!SmagickImage methodsFor: 'accessing' stamp: 'SR 8/26/2007 09:19'!
properties
	^ properties isEmptyOrNil 
		ifTrue: [ properties := self loadProperties ]
		ifFalse: [ properties ]! !

!SmagickImage methodsFor: 'private-accessing' stamp: 'SR 7/12/2007 19:03'!
propertiesProtocol
	^ 'image properties'! !

!SmagickImage methodsFor: 'private-accessing' stamp: 'SR 9/7/2007 18:32'!
propertiesSelectors
	^ self class identifier organization listAtCategoryNamed: self propertiesProtocol! !

!SmagickImage methodsFor: 'image properties' stamp: 'SR 7/12/2007 21:15'!
quantumDepth
	^ self at: #quantumDepth! !

!SmagickImage methodsFor: 'image properties' stamp: 'SR 7/12/2007 21:59'!
scenes
	^ self at: #scenes! !

!SmagickImage methodsFor: 'image properties' stamp: 'SR 7/12/2007 21:13'!
signature
	^ self at: #signature! !

!SmagickImage methodsFor: 'image properties' stamp: 'SR 7/12/2007 21:18'!
uniqueColors
	^ self at: #uniqueColors! !

!SmagickImage methodsFor: 'image properties' stamp: 'SR 7/12/2007 20:40'!
width
	^ self at: #width! !

!SmagickImage methodsFor: 'image properties' stamp: 'SR 7/12/2007 21:29'!
xResolution
	^ self at: #xResolution! !

!SmagickImage methodsFor: 'image properties' stamp: 'SR 7/12/2007 21:29'!
yResolution
	^ self at: #yResolution! !

Smagick subclass: #SmagickTransformation
	instanceVariableNames: 'flags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick'!

SmagickTransformation subclass: #SmagickCompare
	instanceVariableNames: 'difference from to metric'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick'!

!SmagickCompare class methodsFor: 'accessing' stamp: 'SR 8/10/2007 23:38'!
command
	^ #compare! !

!SmagickCompare methodsFor: 'image metrics' stamp: 'SR 8/11/2007 00:50'!
absoluteNumberOfDifferentPixels
	self 
		metric: #absoluteNumberOfDifferentPixels 
		with: 'AE' 
		parser: [ :stream | stream ]! !

!SmagickCompare methodsFor: 'accessing' stamp: 'SR 8/10/2007 23:45'!
difference
	^ difference! !

!SmagickCompare methodsFor: 'accessing' stamp: 'SR 9/1/2007 13:10'!
difference: aFile
	difference := aFile! !

!SmagickCompare methodsFor: 'accessing' stamp: 'SR 8/10/2007 23:45'!
from
	^ from! !

!SmagickCompare methodsFor: 'accessing' stamp: 'SR 8/10/2007 23:45'!
from: aFile
	self assertFileExistence: aFile.
	from := aFile! !

!SmagickCompare methodsFor: 'image metrics' stamp: 'SR 8/11/2007 00:50'!
meanAbsoluteError
	self 
		metric: #meanAbsoluteError
		with: 'MAE' 
		parser: [ :stream | stream ]! !

!SmagickCompare methodsFor: 'image metrics' stamp: 'SR 8/11/2007 00:51'!
meanErrorPerPixel
	self 
		metric: #meanErrorPerPixel
		with: 'MEPP' 
		parser: [ :stream | stream ]! !

!SmagickCompare methodsFor: 'image metrics' stamp: 'SR 8/11/2007 00:51'!
meanSquareError
	self 
		metric: #meanSquareError  
		with: 'MSE'
		parser: [ :stream | stream ]! !

!SmagickCompare methodsFor: 'private' stamp: 'SR 8/11/2007 00:45'!
metric
	^ metric! !

!SmagickCompare methodsFor: 'private-formating' stamp: 'SR 8/11/2007 00:49'!
metric: Symbol with: aString parser: aBlock
	metric := Symbol -> aBlock.
	self resetFlags.
	self put: '-metric' with: aString! !

!SmagickCompare methodsFor: 'private-parsing' stamp: 'SR 8/11/2007 00:45'!
parse: aStream for: aProcess
	| values |
	values := Dictionary new.
	((aStream subStrings: '(,)') first: 3)
		do: [ :each | values 
			at: self metric key 
			put: (self metric value value: each withBlanksTrimmed asNumber) ].
	^ values! !

!SmagickCompare methodsFor: 'image metrics' stamp: 'SR 8/11/2007 00:51'!
peakAbsoluteError
	self 
		metric: #peakAbsoluteError
		with: 'PAE' 
		parser: [ :stream | stream ]! !

!SmagickCompare methodsFor: 'image metrics' stamp: 'SR 8/11/2007 00:51'!
peakSignalToNoiseRatio
	self 
		metric: #peakSignalToNoiseRatio
		with: 'PSNR' 
		parser: [ :stream | stream ]! !

!SmagickCompare methodsFor: 'private-formating' stamp: 'SR 8/11/2007 00:13'!
postOptions
	^ String streamContents: [ :stream | stream 
		nextPutAll: self from asString doubleQuoted; space;
		nextPutAll: self to asString doubleQuoted; space;
		nextPutAll: self difference asString doubleQuoted; space;
		nextPutAll: '>&', self difference asString doubleQuoted, '.', self class name ]! !

!SmagickCompare methodsFor: 'private' stamp: 'SR 8/11/2007 00:32'!
result
	^ self execute result 
		ifNotNilDo: [ :dictionary | self smagick on: self difference with: dictionary ]! !

!SmagickCompare methodsFor: 'image metrics' stamp: 'SR 8/11/2007 00:52'!
rootMeanSquaredError
	self 
		metric: #rootMeanSquaredError 
		with: 'RMSE' 
		parser: [ :stream | stream ]! !

!SmagickCompare methodsFor: 'private' stamp: 'SR 8/11/2007 00:17'!
target
	^ #difference! !

!SmagickCompare methodsFor: 'accessing' stamp: 'SR 8/10/2007 23:45'!
to
	^ to! !

!SmagickCompare methodsFor: 'accessing' stamp: 'SR 8/10/2007 23:45'!
to: aFile
	self assertFileExistence: aFile.
	to := aFile! !

SmagickTransformation subclass: #SmagickCompose
	instanceVariableNames: 'sources to'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick'!

!SmagickCompose class methodsFor: 'accessing' stamp: 'SR 8/10/2007 12:50'!
command
	^ #composite! !

!SmagickCompose methodsFor: 'image compositions' stamp: 'SR 8/10/2007 20:37'!
apply: anOperator with: aFile with: anotherFile
	self apply: anOperator withAll: (Array with: aFile with: anotherFile)
! !

!SmagickCompose methodsFor: 'image compositions' stamp: 'nl 1/15/2008 14:52'!
apply: anOperator withAll: aCollection
	self sources: aCollection.
	self operator: anOperator.
	^ self result
! !

!SmagickCompose methodsFor: 'private-asserting' stamp: 'SR 8/4/2007 11:30'!
assertCompositionOperator: anOperator
	self assert: (self operatorSelectors includes: anOperator)! !

!SmagickCompose methodsFor: 'private' stamp: 'SR 8/10/2007 21:15'!
exceptionClass
	^ SmagickCompositionFailed! !

!SmagickCompose methodsFor: 'private-formating' stamp: 'SR 8/4/2007 11:18'!
operator: anOperator
	self assertCompositionOperator: anOperator.
	flags := '-compose ', (self operators perform: anOperator)! !

!SmagickCompose methodsFor: 'private-formating' stamp: 'SR 8/10/2007 23:30'!
postOptions
	^ self to asString doubleQuoted! !

!SmagickCompose methodsFor: 'private-formating' stamp: 'SR 8/4/2007 11:08'!
preOptions
	^ String streamContents: [ :stream |
		self sources 
			do: [ :from | stream nextPutAll: from ]
			separatedBy: [ stream space ] ]! !

!SmagickCompose methodsFor: 'private' stamp: 'SR 8/4/2007 11:02'!
sources
	^ sources ifNil: [ sources := OrderedCollection new ]! !

!SmagickCompose methodsFor: 'private' stamp: 'SR 8/4/2007 10:56'!
sources: aCollection
	self assert: (aCollection size >= 2).
	aCollection do: [ :each | self assertFileExistence: each ].
	sources := aCollection! !

!SmagickCompose methodsFor: 'accessing' stamp: 'SR 8/4/2007 10:31'!
to
	^to! !

!SmagickCompose methodsFor: 'accessing' stamp: 'SR 8/4/2007 10:31'!
to: anObject
	to := anObject! !

SmagickTransformation subclass: #SmagickConvert
	instanceVariableNames: 'from to'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick'!

!SmagickConvert commentStamp: 'SR 2/12/2008 16:16' prior: 0!
a converter made for images (in general)!

SmagickConvert subclass: #SmagickAnimationConvert
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick'!

!SmagickAnimationConvert commentStamp: 'SR 2/12/2008 16:15' prior: 0!
a converter made specifically for animations (gif)!

SmagickAnimationConvert subclass: #SmagickAnimation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick'!

!SmagickAnimation commentStamp: 'SR 2/12/2008 16:16' prior: 0!
a transformation to *create* animations from images / use SmagickAnimationConvert for conversion!

!SmagickAnimation methodsFor: 'accessing' stamp: 'SR 2/12/2008 16:11'!
add: anImage
	self assertFileExistence: anImage.
	self images add: anImage! !

!SmagickAnimation methodsFor: 'accessing' stamp: 'SR 2/12/2008 16:11'!
from
	^ self images! !

!SmagickAnimation methodsFor: 'accessing' stamp: 'SR 2/12/2008 16:11'!
from: aFileOrCollection
	aFileOrCollection isString
		ifTrue: [ self images: (Array with: aFileOrCollection) ]
		ifFalse: [ self images: aFileOrCollection ]! !

!SmagickAnimation methodsFor: 'accessing' stamp: 'SR 2/13/2008 14:04'!
images
	^ from ifNil: [ from := OrderedCollection new ]
	! !

!SmagickAnimation methodsFor: 'accessing' stamp: 'SR 2/13/2008 14:03'!
images: aCollection
	from := aCollection ! !

!SmagickAnimation methodsFor: 'image properties' stamp: 'SR 2/13/2008 14:00'!
inbetween: anInteger
	" generate and insert anInteger amount of images between each pair of images "
	
	self inbetween: anInteger smooth: false! !

!SmagickAnimation methodsFor: 'image properties' stamp: 'SR 2/13/2008 14:00'!
inbetween: anInteger smooth: aBoolean
	" same as #inbetween: / generate images between the last and the first image if aBoolean is true "
	
	self put: '-morph' with: anInteger asInteger.
	aBoolean ifTrue: [ self images addLast: self images first copy ]! !

!SmagickAnimation methodsFor: 'image properties' stamp: 'SR 2/13/2008 14:00'!
noInbetween
	" do not use inbetweening "
	
	self inbetween: 0! !

!SmagickAnimation methodsFor: 'private-formating' stamp: 'SR 2/12/2008 16:12'!
postOptions
	^  String streamContents: [ :stream |
		self images do: [ :each | stream nextPutAll: each asString doubleQuoted; space ].
		stream nextPutAll: self to asString doubleQuoted ]! !

!SmagickAnimation methodsFor: 'private-formating' stamp: 'SR 2/12/2008 16:12'!
preOptions
	^  ''! !

!SmagickAnimation methodsFor: 'image anim-convenience' stamp: 'SR 2/13/2008 13:59'!
time: aDuration
	" this will create an animation of aDuration length "
	
	self delay: (aDuration asSeconds / self images size - 1) asFloat at: 1! !

!SmagickAnimation methodsFor: 'image anim-convenience' stamp: 'SR 2/13/2008 13:59'!
time: aDuration at: aFloat
	" this will create an animation of aDuration length at aFloat frames per second, using inbetweening "
	
	self inbetween: ((aDuration asSeconds * aFloat) - self images size) / (self images size - 1) asFloat.
	self delay: (1000 / aFloat) asFloat.! !

!SmagickAnimation methodsFor: 'image anim-convenience' stamp: 'SR 2/13/2008 13:59'!
time: aDuration at: aFloat smooth: aBoolean
	" this will create an animation of aDuration length at aFloat frames per second, maybe using smooth inbetweening  "
	
	aBoolean ifTrue: [ self images addLast: self images first copy ].
	self time: aDuration at: aFloat! !

!SmagickAnimationConvert class methodsFor: 'instance creation' stamp: 'SR 12/17/2007 13:25'!
animate: aCollection to: aFile with: aBlock
	| animator |
	animator := (self animate: aCollection to: aFile).
	aBlock value: animator.
	^ animator result! !

!SmagickAnimationConvert methodsFor: 'image quality' stamp: 'SR 2/12/2008 16:43'!
deconstruct
	self put: '-deconstruct'! !

!SmagickAnimationConvert methodsFor: 'image properties' stamp: 'SR 12/19/2007 13:32'!
delay: anInteger
	" set a delay of anInteger milliseconds between each pair of images "
	
	self delay: anInteger at: 1000! !

!SmagickAnimationConvert methodsFor: 'private' stamp: 'SR 12/17/2007 15:08'!
delay: anInteger at: anotherInteger
	self put: '-delay' with: (anInteger asFloat @ anotherInteger) asGeometry! !

!SmagickAnimationConvert methodsFor: 'private-formating' stamp: 'SR 12/17/2007 13:55'!
ensureAnimation: aFilename
	^ ((aFilename last: 4) includesSubstring: '.gif' caseSensitive: false)
		ifTrue: [ aFilename ]
		ifFalse: [ aFilename , '.gif' ]! !

!SmagickAnimationConvert methodsFor: 'image merging' stamp: 'SR 12/19/2007 13:45'!
flatten
	" disabled "! !

!SmagickAnimationConvert methodsFor: 'image merging' stamp: 'SR 12/19/2007 13:45'!
flattenIf: aBoolean
	" disabled "! !

!SmagickAnimationConvert methodsFor: 'image properties' stamp: 'SR 12/19/2007 13:36'!
loop: anInteger
	" make anInteger number of loops"
	
	self 
		put: '-loop'
		with: anInteger asInteger! !

!SmagickAnimationConvert methodsFor: 'image properties' stamp: 'SR 12/19/2007 13:37'!
loopInfinitifely
	" make invinite number of loops "

	self loop: 0! !

!SmagickAnimationConvert methodsFor: 'image quality' stamp: 'SR 12/19/2007 14:02'!
optimize
	self layers: 'optimize-plus'! !

!SmagickAnimationConvert methodsFor: 'image quality' stamp: 'SR 12/19/2007 14:02'!
optimizeFrames
	self layers: 'optimize-frame'! !

!SmagickAnimationConvert methodsFor: 'image quality' stamp: 'SR 12/19/2007 13:59'!
optimizeTransparency
	self layers: 'optimize-transparency'! !

!SmagickAnimationConvert methodsFor: 'image quality' stamp: 'SR 12/19/2007 14:02'!
removeDuplicates
	self layers: 'remove-dups'! !

!SmagickAnimationConvert methodsFor: 'accessing' stamp: 'SR 12/17/2007 13:29'!
to: aFilename
	to := self ensureAnimation: aFilename! !

!SmagickAnimationConvert methodsFor: 'image quality' stamp: 'SR 12/19/2007 13:26'!
useFullFramesOnly
	" best quality, largest file size "
	
	self put: '-coalesce'! !

!SmagickAnimationConvert methodsFor: 'image quality' stamp: 'SR 12/19/2007 14:22'!
useGlobalColorTable
	" reduced file size, no color loss"
	
	self put: '+map'! !

!SmagickAnimationConvert methodsFor: 'image quality' stamp: 'SR 12/19/2007 14:16'!
useOptimizedGlobalColorTable
	" optimize the global color table, use aPattern to reduce colors "
	
	self useOptimizedGlobalColorTable: nil! !

!SmagickAnimationConvert methodsFor: 'image quality' stamp: 'SR 12/19/2007 14:16'!
useOptimizedGlobalColorTable: aPattern
	" optimize the global color table, use aPattern to reduce colors "
	
	self optimizeTransparency.
	aPattern ifNotNil: [ self put: '-ordered-dither' with: aPattern ].
	self useGlobalColorTable! !

!SmagickAnimationConvert methodsFor: 'image quality' stamp: 'SR 12/19/2007 13:39'!
useReducedGlobalColorTable
	" same as #useGlobalColorTable, limit color table to 256 colors "
	
	self put: '-map'! !

!SmagickConvert class methodsFor: 'accessing' stamp: 'SR 8/10/2007 12:51'!
command
	^ #convert! !

!SmagickConvert methodsFor: 'image merging' stamp: 'SR 6/30/2007 22:10'!
adjoin
	self put: '-adjoin'! !

!SmagickConvert methodsFor: 'image merging' stamp: 'SR 6/30/2007 22:10'!
adjoinForce
	self put: '+adjoin'! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 6/30/2007 22:05'!
antialias
	self put: '-antialias' ! !

!SmagickConvert methodsFor: 'image drawing' stamp: 'nl 1/16/2008 11:39'!
append: aCollection	
	aCollection do: [:file |
		self assertFileExistence: file.
		self put: file ].
	self put: '-append' .! !

!SmagickConvert methodsFor: 'image drawing' stamp: 'nl 1/16/2008 11:39'!
appendRight: aCollection  
	aCollection do: [:file |
		self assertFileExistence: file.
		self put: file ].
	self put: '+append' .! !

!SmagickConvert methodsFor: 'private-asserting' stamp: 'SR 8/4/2007 09:15'!
assertChannels: aCollection
	^ aCollection allSatisfy: [ :each | self channelConstants includes: each ]! !

!SmagickConvert methodsFor: 'image settings' stamp: 'SR 6/30/2007 22:05'!
authenticate: aString
	self
		put: '-authenticate' 
		with: aString! !

!SmagickConvert methodsFor: 'image orientation' stamp: 'SR 6/30/2007 22:05'!
autoOriented
	self put: '-auto-orient' ! !

!SmagickConvert methodsFor: 'image settings' stamp: 'SR 6/30/2007 22:05'!
average
	self put: '-average'! !

!SmagickConvert methodsFor: 'image settings' stamp: 'SR 6/30/2007 22:09'!
backdrop: aColor
	self 
		put: '-backdrop' 
		with: aColor! !

!SmagickConvert methodsFor: 'image settings' stamp: 'SR 6/30/2007 22:05'!
bias: aNumber percentage: aBoolean
	self 
		put: '-bias' 
		with: aNumber
		postfix: (aBoolean ifTrue: [ '%' ] ifFalse: [ '' ])! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 8/4/2007 09:11'!
bilevel
	self type: self constants bilevel! !

!SmagickConvert methodsFor: 'image settings' stamp: 'SR 6/30/2007 22:05'!
blackPointCompensation
	self put: '-black-point-compensation' ! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 6/30/2007 22:05'!
blackThreshold: aNumber
	self
		put: '-black-threshold' 
		with: aNumber 
		postfix: '%'! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 6/30/2007 22:05'!
blur: aPointOrNumber
	" aPointOrNumber = radius[0..1] @ sigma "
	self 
		put: '-blur' 
		with: aPointOrNumber asGeometry! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 7/2/2007 13:19'!
blurGaussian: aPointOrNumber
	self 
		put: '-gaussian-blur' 
		with: aPointOrNumber asGeometry! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 6/30/2007 22:05'!
blurRadial: aFloat
	self 
		put: '-radial-blur' 
		with: aFloat! !

!SmagickConvert methodsFor: 'image settings' stamp: 'SR 7/2/2007 12:20'!
border: anInteger color: aColor
	self 
		put: '-bordercolor' 
		with: aColor.
	self 
		put: '-border' 
		with: anInteger.
	! !

!SmagickConvert methodsFor: 'private' stamp: 'SR 8/11/2007 18:16'!
canvas
	^ SmagickCanvas new
		converter: self;
		yourself! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 6/30/2007 22:06'!
charcoal: aNumber
	self 
		put: '-charcoal' 
		with: aNumber! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 8/4/2007 09:11'!
colorSeparation
	self type: self constants colorSeparation! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 8/4/2007 09:11'!
colorSeparationMatte
	self type: self constants colorSeparationMatte! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 9/9/2007 11:31'!
colors: anInteger
	self 
		put: '-colors'
		with: anInteger! !

!SmagickConvert methodsFor: 'private-formating' stamp: 'SR 7/2/2007 12:39'!
compress: aCompression
	self 
		put: '-compress' 
		with: aCompression! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 7/2/2007 12:51'!
contrast: aNumber
	| selector |
	aNumber = 0 ifTrue: [ ^ self ].
	aNumber > 0 
		ifTrue: [ selector := #moreContrast ]
		ifFalse: [ selector := #lessContrast ].
	1 to: aNumber abs do: [ :i |
		self perform: selector ]! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 5/5/2008 17:32'!
crop: aPoint width: aNumber height: anotherNumber
	self crop: aPoint width: aNumber height: anotherNumber repage: true! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 5/5/2008 17:38'!
crop: aPoint width: aNumber height: anotherNumber repage: aBoolean
	self put: '-crop'
		with: (SmagickGeometry new
			xoffset: aPoint x yoffset: aPoint y;
			width: aNumber height: anotherNumber;
			beNormal;
			yourself).
	self repage: aBoolean! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 5/5/2008 17:25'!
cropFrom: aPoint to: anotherPoint
	self cropFrom: aPoint to: anotherPoint repage: true! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 5/5/2008 17:51'!
cropFrom: aPoint to: anotherPoint repage: aBoolean
	self crop: aPoint 
		width: aPoint x + anotherPoint x
		height: aPoint y + anotherPoint y
		repage: aBoolean! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 11/8/2007 10:05'!
density: aPoint
	self 
		put: '-density' 
		with: aPoint asGeometry! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 3/26/2008 08:55'!
depth: anInteger
	" color depth primarily depends on the image format read/written: default is 24 bit, most formats understand 8, 16 or 24 bits. Tiff also supports 12, 14 and 32 bits. For more see Image magick documentation "
	self assert: (anInteger \\ 2) = 0.
	self 
		put: '-depth' 
		with: anInteger! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 7/2/2007 12:53'!
despeckle
	self put: '-despeckle' ! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 7/2/2007 13:10'!
emboss: aFloat
	self 
		put: '-emboss' 
		with: aFloat! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 7/2/2007 13:11'!
enhance
	self put: '-enhance'! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 7/2/2007 13:11'!
equalize
	self put: '-equalize'! !

!SmagickConvert methodsFor: 'private' stamp: 'SR 8/10/2007 21:15'!
exceptionClass
	^ SmagickConvertFailed! !

!SmagickConvert methodsFor: 'image settings' stamp: 'nl 1/16/2008 11:11'!
extent: aPoint
	" aPoint = x [@ y] "
	self 
		put: '-extent' 
		with: aPoint asGeometry! !

!SmagickConvert methodsFor: 'image merging' stamp: 'SR 10/18/2007 16:04'!
flatten
	self put: '-flatten'! !

!SmagickConvert methodsFor: 'image merging' stamp: 'SR 11/22/2007 18:22'!
flattenIf: aBoolean
	aBoolean ifTrue: [ self put: '-flatten' ]! !

!SmagickConvert methodsFor: 'image orientation' stamp: 'SR 7/2/2007 12:23'!
flip
	self put: '-flip'! !

!SmagickConvert methodsFor: 'image orientation' stamp: 'SR 7/2/2007 13:16'!
flop
	self put: '-flop'! !

!SmagickConvert methodsFor: 'accessing' stamp: 'SR 7/9/2007 13:49'!
from
	^ from! !

!SmagickConvert methodsFor: 'accessing' stamp: 'SR 7/14/2007 18:10'!
from: aFile
	self assertFileExistence: aFile.
	from := aFile! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 7/2/2007 13:17'!
gamma: aFloat
	self 
		 put: '-gamma'
		with: aFloat! !

!SmagickConvert methodsFor: 'image drawing' stamp: 'nl 1/16/2008 11:45'!
gravity: anOrientation
	self put: '-gravity' with: anOrientation ! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 8/4/2007 09:11'!
grayscale
	self type: self constants grayscale! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 12/19/2007 13:55'!
layers: aLayer
	self put: '-layers' with: aLayer! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 7/2/2007 12:52'!
lessContrast
	self put: '+contrast'! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 7/2/2007 12:22'!
makeTransparent: aColor
	self 
		put: '-transparent'
		with: aColor! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 7/2/2007 12:52'!
moreContrast
	self put: '-contrast'! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 7/2/2007 13:20'!
negate
	self put: '-negate' ! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 7/2/2007 13:21'!
normalize
	self put: '-normalize'! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 8/4/2007 09:11'!
optimizedColor
	self type: self constants optimizedColor! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 7/2/2007 11:57'!
paint: aNumber
	self 
		put: '-paint' 
		with: aNumber! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 8/4/2007 09:11'!
palette
	self type: self constants palette! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 8/4/2007 09:11'!
paletteMatte
	self type: self constants paletteMatte! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 7/2/2007 13:22'!
polaroid: aNumber
	self 
		put: '-polaroid' 
		with: aNumber! !

!SmagickConvert methodsFor: 'private-formating' stamp: 'SR 9/9/2007 13:17'!
postOptions
	^ (self to ifNil: [ self from ]) asString doubleQuoted! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 7/2/2007 11:58'!
posterize: aNumber
	self 
		put: '-posterize' 
		with: aNumber! !

!SmagickConvert methodsFor: 'private-formating' stamp: 'SR 7/14/2007 18:04'!
preOptions
	^ self from asString doubleQuoted! !

!SmagickConvert methodsFor: 'private' stamp: 'SR 8/11/2007 19:01'!
primitive: aPrimitive
	aPrimitive appendTo: self flags! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 7/2/2007 12:07'!
quality: aNumber
	self 
		put: '-quality' 
		with: aNumber
		postfix: '%'! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 6/30/2007 22:06'!
raise: aPoint
	self 
		put: '-raise' 
		with: aPoint asGeometry! !

!SmagickConvert methodsFor: 'image drawing' stamp: 'nl 1/16/2008 15:07'!
region: aString
	self put: '-region' with: aString  ! !

!SmagickConvert methodsFor: 'image orientation' stamp: 'SR 5/5/2008 17:33'!
repage
	self repage: true! !

!SmagickConvert methodsFor: 'image orientation' stamp: 'SR 5/5/2008 17:33'!
repage: aBoolean
	" remove the original size information from the image <--> crop "
	aBoolean ifTrue: [ self put: '+repage' ]! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 7/2/2007 12:11'!
resample: aPoint
	self 
		put: '-resample' 
		with: aPoint asGeometry! !

!SmagickConvert methodsFor: 'image settings' stamp: 'SR 7/14/2007 21:01'!
resize: aPoint
	" resize all , keep aspects, aPoint = x [@ y]"
	self 
		put: '-resize' 
		with: aPoint asGeometry! !

!SmagickConvert methodsFor: 'private-formating' stamp: 'SR 7/2/2007 13:13'!
resize: aPoint with: aFilter
	" resize all , keep aspects "
	self 
		put: '-filter' 
		with: aFilter.
	self 
		put: '-resize' 
		with: aPoint asGeometry! !

!SmagickConvert methodsFor: 'image settings' stamp: 'SR 6/30/2007 21:55'!
resizeHeight: anInteger
	" resize height , keep aspects "
	self resize: (nil@anInteger)! !

!SmagickConvert methodsFor: 'image settings' stamp: 'SR 11/12/2007 16:07'!
resizeWidth: anInteger
	" resize width , keep aspects "
	self resize: (Point x: anInteger y: nil)! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 5/5/2008 14:45'!
resolution: anInteger
	self density: (anInteger @ anInteger)! !

!SmagickConvert methodsFor: 'image orientation' stamp: 'SR 6/30/2007 21:55'!
rotate: anInteger
	" 0 < anInteger < 360 "
	self rotate: anInteger postfix: ''! !

!SmagickConvert methodsFor: 'private-formating' stamp: 'SR 6/30/2007 22:03'!
rotate: anInteger postfix: aString
	self 
		put: '-rotate' 
		with: anInteger 
		postfix: aString! !

!SmagickConvert methodsFor: 'image orientation' stamp: 'SR 6/30/2007 21:55'!
rotateForceLandscape: anInteger
	self rotate: anInteger postfix: '>'! !

!SmagickConvert methodsFor: 'image orientation' stamp: 'SR 6/30/2007 21:55'!
rotateForcePortrait: anInteger
	self rotate: anInteger postfix: '<'! !

!SmagickConvert methodsFor: 'image settings' stamp: 'SR 7/14/2007 20:59'!
scale: aPoint
	" aPoint = x [@ y] "
	self 
		put: '-scale' 
		with: aPoint asGeometry! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 6/30/2007 22:06'!
sepia: aFloat
	" 0 < aFloat < 99.9 "
	self 
		put: '-sepia-tone' 
		with: aFloat
		postfix: '%'! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 7/2/2007 12:22'!
setTransparent: aColor
	self 
		put: '-transparent-color'
		with: aColor! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 6/30/2007 22:06'!
shade: aPoint
	" aPoint = azimuth @ elevation "
	self 
		put: '-shade' 
		with: aPoint asGeometry! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 6/30/2007 22:06'!
shadeGray: aPoint
	" aPoint = azimuth @ elevation "
	self 
		put: '+shade' 
		with: aPoint asGeometry! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 6/30/2007 22:06'!
sharpen: aPointOrNumber
	" aPoint = radius[0..1] @ sigma "
	self 
		put: '-sharpen' 
		with: aPointOrNumber asGeometry! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 6/30/2007 22:06'!
sharpenAdaptive: aPointOrNumber
	" aPoint = radius[0..1] @ sigma "
	self 
		put: '-adaptive-sharpen' 
		with: aPointOrNumber asGeometry! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 6/30/2007 21:55'!
shave: aPoint
	" remove aPoint->x and aPoint->y pixels from all sides "
	self shave: aPoint percentage: false! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 6/30/2007 22:06'!
shave: aPoint percentage: aBoolean
	self 
		put: '-shave' 
		with: aPoint asGeometry
		postfix: (aBoolean ifTrue: [ '%' ] ifFalse: [ '' ])! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 6/30/2007 22:07'!
shear: aPoint
	" aPoint = radius[0..1] @ sigma "
	self 
		put: '-shear' 
		with: aPoint asGeometry! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 6/30/2007 22:07'!
sketch: aNumber
	self 
		put: '-sketch' 
		with: aNumber! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 6/30/2007 22:07'!
solarize: aFloat
	" 0 < aFloat < 99.9 "
	self 
		put: '-solarize' 
		with: aFloat
		postfix: '%'! !

!SmagickConvert methodsFor: 'image merging' stamp: 'SR 6/30/2007 22:10'!
stereo
	" create a stereo anaglyph from the image "
	self put: '-stereo'! !

!SmagickConvert methodsFor: 'image settings' stamp: 'SR 6/30/2007 22:07'!
strip
	" remove any proflie data or ... "
	self put: '-strip'! !

!SmagickConvert methodsFor: 'image parameters' stamp: 'SR 7/2/2007 12:16'!
stroke: aColor
	self stroke: aColor width: 1! !

!SmagickConvert methodsFor: 'image parameters' stamp: 'SR 7/2/2007 12:20'!
stroke: aColor width: aNumber
	self 
		put: '-strokewidth'
		with: aNumber.
	self 
		put: '-stroke' 
		with: aColor.
	! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 6/30/2007 22:07'!
swirl: aFloat
	self 
		put: '-swirl' 
		with: aFloat! !

!SmagickConvert methodsFor: 'image settings' stamp: 'nl 7/6/2007 13:09'!
thumbnail: aPoint
	" same as resize but without image profile data "
	self 
		put: '-thumbnail' 
		with: aPoint asGeometry! !

!SmagickConvert methodsFor: 'image settings' stamp: 'nl 7/6/2007 13:09'!
thumbnailWidth: anInteger
	self thumbnail: (anInteger@nil)! !

!SmagickConvert methodsFor: 'accessing' stamp: 'SR 7/9/2007 13:24'!
to
	^ to! !

!SmagickConvert methodsFor: 'accessing' stamp: 'SR 9/1/2007 13:10'!
to: aFile
	to := aFile! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 7/2/2007 12:23'!
transpose
	self put: '-transpose'! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 8/4/2007 09:11'!
trueColor
	self type: self constants trueColor! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 8/4/2007 09:11'!
trueColorMatte
	self type: self constants trueColorMatte! !

!SmagickConvert methodsFor: 'private-formating' stamp: 'SR 7/2/2007 12:24'!
type: aType
	self 
		put: '-type'
		with: aType! !

!SmagickConvert methodsFor: 'image parameters' stamp: 'SR 11/8/2007 15:52'!
units: aString
	self 
		put: '-units'
		with: aString.! !

!SmagickConvert methodsFor: 'image quality' stamp: 'SR 7/2/2007 12:35'!
unsharp: aPointOrNumber
	" aPoint = radius[0..1] @ sigma "
	self 
		put: '-unsharp' 
		with: aPointOrNumber asGeometry! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 7/2/2007 12:36'!
vignette: aPointOrNumber
	" aPoint = radius[0..1] @ sigma "
	self 
		put: '-vignette' 
		with: aPointOrNumber asGeometry! !

!SmagickConvert methodsFor: 'image parameters' stamp: 'SR 7/2/2007 12:37'!
watermarkVisibility: aNumber
	self 
		put: '-watermark'
		with: aNumber
		postfix: '%'! !

!SmagickConvert methodsFor: 'image effects' stamp: 'SR 7/2/2007 12:38'!
wave: aPointOrNumber
	" aPoint = radius[0..1] @ sigma "
	self 
		put: '-wave' 
		with: aPointOrNumber asGeometry! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 7/2/2007 12:38'!
whiteThreshold: aNumber
	self
		put: '-white-threshold' 
		with: aNumber 
		postfix: '%'! !

!SmagickConvert methodsFor: 'image drawing' stamp: 'SR 8/26/2007 16:23'!
with: aBlock
	aBlock value: self canvas! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 8/4/2007 09:49'!
withChannel: aChannel do: aBlock
	" set operations of ablock to aChannel "
	self put: '-channel' with: aChannel.
	aBlock value: self.
	
	 " reset again to default channel (=RGB) "
	self put: '+channel'.! !

!SmagickConvert methodsFor: 'image colors' stamp: 'SR 8/4/2007 09:45'!
withChannels: aCollectionOfChannels do: aBlock
	self assertChannels: aCollectionOfChannels.
	self withChannel: (String streamContents: [ :stream |
		aCollectionOfChannels 
			do: [ :each | stream nextPutAll: each ] 
			separatedBy: [ stream comma ] ]) do: aBlock! !

SmagickTransformation subclass: #SmagickIdentify
	instanceVariableNames: 'from formats'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick'!

!SmagickIdentify commentStamp: 'SR 7/14/2007 13:39' prior: 0!
IMPORTANT: 
we cannot parse all exif at once -> exceeding command line parameters !! 
-> only a selection of possibly interesting tags used!

!SmagickIdentify class methodsFor: 'accessing' stamp: 'SR 8/10/2007 12:51'!
command
	^ #identify! !

!SmagickIdentify methodsFor: 'image properties' stamp: 'SR 8/4/2007 08:40'!
boundingBox
	self 
		format: #boundingBox 
		using: '%@'
		parser: [ :string | SmagickGeometry from: string ]! !

!SmagickIdentify methodsFor: 'image properties' stamp: 'SR 7/12/2007 23:25'!
compressionQualty
	self 
		format: #compressionQualty 
		using: '%Q' 
		parser: self numberBlock! !

!SmagickIdentify methodsFor: 'image properties' stamp: 'SR 7/12/2007 23:11'!
compressionType
	self 
		format: #compressionType 
		using: '%C'! !

!SmagickIdentify methodsFor: 'private' stamp: 'SR 8/10/2007 21:15'!
exceptionClass
	^ SmagickIdentifyFailed! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:55'!
exifApertureValue
	self exifString: #ApertureValue! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:47'!
exifArtist
	self exifString: #Artist
		! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:16'!
exifBatteryLevel
	self exifString: #BatteryLevel! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:36'!
exifBitsPerSample
	self exifNumber: #BitsPerSample
		! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:56'!
exifBrightnessValue
	self exifString: #BrightnessValue! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:16'!
exifCFAPattern
	self exifString: #CFAPattern! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:16'!
exifCFARepeatPatternDim
	self exifString: #CFARepeatPatternDim! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:17'!
exifComponentsConfiguration
	self exifString: #ComponentsConfiguration! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:18'!
exifCompressedBitsPerPixel
	self exifString: #CompressedBitsPerPixel! !

!SmagickIdentify methodsFor: 'image printers' stamp: 'SR 7/14/2007 13:55'!
exifCopyright
	self exifString: #Copyright! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:46'!
exifDateTime
	self exifString: #DateTime
		! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:54'!
exifExifVersion
	self exifString: #ExifVersion! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:56'!
exifExposureBiasValue
	self exifString: #ExposureBiasValue! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:19'!
exifExposureIndex
	self exifString: #ExposureIndex! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:17'!
exifExposureProgram
	self exifString: #ExposureProgram! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:54'!
exifExposureTime
	self exifString: #ExposureTime! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:17'!
exifFNumber
	self exifString: #FNumber! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:13'!
exifFillOrder
	self exifString: #FillOrder! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:58'!
exifFlashEnergy
	self exifString: #FlashEnergy! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:57'!
exifFocalLength
	self exifString: #FocalLength! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:54'!
exifGPSInfo
	self exifString: #GPSInfo! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:40'!
exifImageDescription
	self exifString: #ImageDescription
		! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:17'!
exifInterColorProfile
	self exifString: #InterColorProfile! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:52'!
exifJPEGInterchangeFormat
	self exifString: #JPEGInterchangeFormat! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:52'!
exifJPEGInterchangeFormatLength
	self exifNumber: #JPEGInterchangeFormatLength! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:15'!
exifJPEGProc
	self exifString: #JPEGProc! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:18'!
exifLightSource
	self exifString: #LightSource! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:59'!
exifMaxApertureValue
	self exifString: #MaxApertureValue! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:57'!
exifMeteringMode
	self exifString: #MeteringMode! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:13'!
exifModel
	self exifString: #Model! !

!SmagickIdentify methodsFor: 'private-formating' stamp: 'SR 7/14/2007 13:49'!
exifNumber: aSymbol
	self 
		format: (self exifSymbol: aSymbol)
		using: (self exifTag: aSymbol) 
		parser: self numberBlock! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:40'!
exifOrientation
	self exifString: #Orientation! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:12'!
exifPhotometricInterpretation
	self exifString: #PhotometricInterpretation! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:13'!
exifPlanarConfiguration
	self exifString: #PlanarConfiguration! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:14'!
exifPrimaryChromaticities
	self exifString: #PrimaryChromaticities! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:16'!
exifReferenceBlackWhite
	self exifString: #ReferenceBlackWhite! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:14'!
exifResolutionUnit
	self exifString: #ResolutionUnit! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:46'!
exifSamplesPerPixel
	self exifNumber: #SamplesPerPixel! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:58'!
exifSceneType
	self exifString: #SceneType! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:58'!
exifSensingMethod
	self exifString: #SensingMethod! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:55'!
exifShutterSpeedValue
	self exifString: #ShutterSpeedValue! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:14'!
exifSoftware
	self exifString: #Software! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:55'!
exifSpectralSensitivity
	self exifString: #SpectralSensitivity! !

!SmagickIdentify methodsFor: 'private-formating' stamp: 'SR 7/14/2007 13:50'!
exifString: aSymbol
	self 
		format: (self exifSymbol: aSymbol)
		using: (self exifTag: aSymbol) 
		parser: self stringBlock! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:57'!
exifSubjectDistance
	self exifString: #SubjectDistance! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:19'!
exifSubjectLocation
	self exifString: #SubjectLocation! !

!SmagickIdentify methodsFor: 'private-parsing' stamp: 'SR 7/14/2007 13:51'!
exifSymbol: aSymbol
	^ ('exif', aSymbol asString) asSymbol! !

!SmagickIdentify methodsFor: 'private-formating' stamp: 'SR 7/14/2007 13:50'!
exifTag: aSymbol
	^ '%[exif:', aSymbol asString, ']'! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:14'!
exifTransferFunction
	self exifString: #TransferFunction! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:14'!
exifTransferRange
	self exifString: #TransferRange! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:58'!
exifUserComment
	self exifString: #UserComment! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 13:46'!
exifWhitePoint
	self exifString: #WhitePoint
		! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:15'!
exifYCbCrCoefficients
	self exifString: #YCbCrCoefficients! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:15'!
exifYCbCrPositioning
	self exifString: #YCbCrPositioning! !

!SmagickIdentify methodsFor: 'image exif properties' stamp: 'SR 7/14/2007 14:15'!
exifYCbCrSubSampling
	self exifString: #YCbCrSubSampling! !

!SmagickIdentify methodsFor: 'image properties' stamp: 'SR 7/14/2007 12:39'!
fileExtension
	self 
		format: #fileExtension 
		using: '%e'! !

!SmagickIdentify methodsFor: 'image properties' stamp: 'SR 7/14/2007 12:43'!
fileName
	self 
		format: #fileName 
		using: '%t'! !

!SmagickIdentify methodsFor: 'image properties' stamp: 'SR 7/14/2007 12:39'!
fileSize
	self 
		format: #fileSize
		using: '%b'! !

!SmagickIdentify methodsFor: 'private-parsing' stamp: 'SR 8/3/2007 16:12'!
form
	^ self boundingBox asForm! !

!SmagickIdentify methodsFor: 'private-formating' stamp: 'SR 7/12/2007 23:25'!
format: aSymbol using: aString
	^ self 
		format: aSymbol 
		using: aString 
		parser: self stringBlock! !

!SmagickIdentify methodsFor: 'private-formating' stamp: 'SR 7/12/2007 23:25'!
format: aSymbol using: aString parser: aBlock
	self formats add: (self unary: aSymbol format: aString parser: aBlock)! !

!SmagickIdentify methodsFor: 'private-formating' stamp: 'SR 7/14/2007 17:02'!
formats
	^ formats ifNil: [formats := SmagickFormatProperties new]! !

!SmagickIdentify methodsFor: 'private-formating' stamp: 'SR 7/12/2007 23:32'!
formats: aCollection using: aString parsers: anotherCollection
	self formats add: (self nary: aCollection using: aString parsers: anotherCollection)! !

!SmagickIdentify methodsFor: 'accessing' stamp: 'SR 7/9/2007 13:41'!
from
	^ from! !

!SmagickIdentify methodsFor: 'accessing' stamp: 'SR 7/14/2007 18:10'!
from: aFile
	self assertFileExistence: aFile.
	from := aFile! !

!SmagickIdentify methodsFor: 'image properties' stamp: 'SR 7/12/2007 23:25'!
height
	self 
		format: #height 
		using: '%h' 
		parser: self numberBlock! !

!SmagickIdentify methodsFor: 'image properties' stamp: 'SR 7/14/2007 12:42'!
imageClassAndColorspace
	self 
		format: #imageClassAndColorspace 
		using: '%r'! !

!SmagickIdentify methodsFor: 'image properties' stamp: 'SR 7/14/2007 12:47'!
imageDelay
	self 
		format: #imageDelay 
		using: '%T'
		parser: self numberBlock! !

!SmagickIdentify methodsFor: 'image properties' stamp: 'SR 7/14/2007 12:43'!
imageName
	self 
		format: #imageName 
		using: '%f'! !

!SmagickIdentify methodsFor: 'image properties' stamp: 'SR 7/14/2007 12:41'!
magick
	self 
		format: #magick 
		using: '%m'! !

!SmagickIdentify methodsFor: 'private-formating' stamp: 'SR 7/14/2007 17:02'!
nary: aCollection using: aString parsers: anotherCollection 
	^ (SmagickNaryFormatProperty new)
		formats: aCollection;
		symbol: aString;
		parsers: anotherCollection;
		yourself! !

!SmagickIdentify methodsFor: 'private-parsing' stamp: 'SR 7/14/2007 13:51'!
numberBlock 
	^ [ :value | value ifNotNil: [ value asInteger ] ]! !

!SmagickIdentify methodsFor: 'private-parsing' stamp: 'SR 7/14/2007 13:00'!
offsetParser 
	^ [ :value | | last valueCopy |
		last := (value lastIndexOf: $+) max: (value lastIndexOf: $-).
		valueCopy := value copyReplaceAll: '+' with: ' '.
		(valueCopy copyFrom: 1 to: last) asNumber @ (valueCopy copyFrom: last to: value size) asNumber ]! !

!SmagickIdentify methodsFor: 'private-formating' stamp: 'SR 7/9/2007 23:28'!
options
	^ String streamContents: [ :stream |
		stream nextPutAll: super options; space.
		self formats printOn: stream ]! !

!SmagickIdentify methodsFor: 'image properties' stamp: 'SR 7/14/2007 13:05'!
pageDimension
	self pageWidth; pageHeight! !

!SmagickIdentify methodsFor: 'image properties' stamp: 'SR 7/14/2007 13:06'!
pageGeometry
	self pageWidth; pageHeight; pageOffset! !

!SmagickIdentify methodsFor: 'image properties' stamp: 'SR 7/14/2007 12:46'!
pageHeight
	self 
		format: #pageHeight 
		using: '%P'
		parser: [ :value | self numberBlock value: (value copyAfter: $x) ]! !

!SmagickIdentify methodsFor: 'image properties' stamp: 'SR 7/14/2007 12:41'!
pageNumber
	self 
		format: #pageNumber 
		using: '%n'! !

!SmagickIdentify methodsFor: 'image properties' stamp: 'SR 7/14/2007 12:51'!
pageOffset
	self 
		format: #pageOffset 
		using: '%O'
		parser: self offsetParser! !

!SmagickIdentify methodsFor: 'image properties' stamp: 'SR 7/14/2007 12:46'!
pageWidth
	self 
		format: #pageWidth 
		using: '%P'
		parser: [ :value | self numberBlock value: (value copyUpTo: $x) ]! !

!SmagickIdentify methodsFor: 'private-parsing' stamp: 'SR 2/11/2008 10:07'!
parse: aStream for: aProcess
	| values formatTokens |
	values := Dictionary new.
	aStream isEmpty ifTrue: [ ^ values ].
	formatTokens := self formats parse: aStream.
	1 to: self formats size do: [ :i |
		((self formats at: i) parse: ((formatTokens at: i) substrings)) 
			do: [ :assoc | values at: assoc key put: assoc value ] ].
	^ values! !

!SmagickIdentify methodsFor: 'private-formating' stamp: 'SR 7/14/2007 18:04'!
postOptions
	^ self from asString doubleQuoted! !

!SmagickIdentify methodsFor: 'image properties' stamp: 'SR 7/12/2007 23:25'!
quantumDepth
	self 
		format: #quantumDepth 
		using: '%q' 
		parser: self numberBlock! !

!SmagickIdentify methodsFor: 'image properties' stamp: 'SR 8/4/2007 08:40'!
rawBoundingBox
	self 
		format: #boundingBox 
		using: '%@'
		parser: [ :string | SmagickGeometry from: string ]! !

!SmagickIdentify methodsFor: 'private' stamp: 'SR 8/10/2007 20:58'!
result
	^ self smagick on: self from! !

!SmagickIdentify methodsFor: 'image properties' stamp: 'SR 7/12/2007 23:25'!
scenes
	self 
		format: #scenes 
		using: '%n' 
		parser: self numberBlock! !

!SmagickIdentify methodsFor: 'image properties' stamp: 'SR 7/12/2007 23:11'!
signature
	self 
		format: #signature 
		using: '%#'! !

!SmagickIdentify methodsFor: 'private-parsing' stamp: 'SR 7/14/2007 13:20'!
stringBlock 
	^ [ :value | ((value = 'nil') or: [ value = 'Undefined' ]) ifTrue: [ nil ] ifFalse: [ value ] ]! !

!SmagickIdentify methodsFor: 'private' stamp: 'SR 8/11/2007 00:02'!
target
	^ #from! !

!SmagickIdentify methodsFor: 'accessing' stamp: 'SR 7/9/2007 16:15'!
to
	^ self from! !

!SmagickIdentify methodsFor: 'private-formating' stamp: 'SR 7/14/2007 17:02'!
unary: aSymbol format: aString parser: aBlock 
	^ (SmagickUnaryFormatProperty new)
		format: aSymbol;
		symbol: aString;
		parser: aBlock;
		yourself! !

!SmagickIdentify methodsFor: 'image properties' stamp: 'SR 7/12/2007 23:25'!
uniqueColors
	self 
		format: #uniqueColors 
		using: '%k' 
		parser: self numberBlock! !

!SmagickIdentify methodsFor: 'image printers' stamp: 'SR 7/9/2007 13:51'!
verbose
	self put: '-verbose'! !

!SmagickIdentify methodsFor: 'image properties' stamp: 'SR 7/12/2007 23:25'!
width
	self 
		format: #width 
		using: '%w' 
		parser: self numberBlock! !

!SmagickIdentify methodsFor: 'image properties' stamp: 'SR 7/12/2007 23:31'!
xResolution
	self 
		formats: #(xResolution xResolutionScale)
		using: '%x' 
		parsers: { self numberBlock. self stringBlock }! !

!SmagickIdentify methodsFor: 'image properties' stamp: 'SR 7/12/2007 21:57'!
xResolutionScale
	self xResolution! !

!SmagickIdentify methodsFor: 'image properties' stamp: 'SR 7/12/2007 23:31'!
yResolution
	self 
		formats: #(yResolution yResolutionScale)
		using: '%y' 
		parsers: { self numberBlock. self stringBlock }! !

!SmagickIdentify methodsFor: 'image properties' stamp: 'SR 7/12/2007 21:57'!
yResolutionScale
	self yResolution! !

SmagickTransformation subclass: #SmagickLogo
	instanceVariableNames: 'to'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick'!

!SmagickLogo class methodsFor: 'accessing' stamp: 'SR 8/10/2007 13:16'!
command
	^ #convert! !

!SmagickLogo class methodsFor: 'actions' stamp: 'SR 8/10/2007 13:28'!
on: aFile
	^ (self new to: aFile; yourself) asSmagickImage! !

!SmagickLogo methodsFor: 'private' stamp: 'SR 8/10/2007 21:15'!
exceptionClass
	^ SmagickConvertFailed! !

!SmagickLogo methodsFor: 'private-formating' stamp: 'SR 8/10/2007 13:21'!
postOptions
	^ self to asString doubleQuoted! !

!SmagickLogo methodsFor: 'private-formating' stamp: 'SR 8/10/2007 13:27'!
preOptions
	^ 'logo:'! !

!SmagickLogo methodsFor: 'accessing' stamp: 'SR 8/10/2007 13:14'!
to
	^ to! !

!SmagickLogo methodsFor: 'accessing' stamp: 'SR 9/1/2007 13:10'!
to: aFile
	to := aFile! !

!SmagickTransformation class methodsFor: 'accessing' stamp: 'SR 8/10/2007 12:51'!
command
	^ self subclassResponsibility ! !

!SmagickTransformation class methodsFor: 'testing' stamp: 'SR 9/1/2007 13:12'!
existsIn: anEnvironment
	^ anEnvironment streamClass isAFileNamed: (anEnvironment commandFor: self)! !

!SmagickTransformation class methodsFor: 'accessing' stamp: 'SR 9/7/2007 18:15'!
tools
	^ self subclasses collect: [ :each | each ]! !

!SmagickTransformation methodsFor: 'converting' stamp: 'SR 8/4/2007 11:58'!
asSmagickImage
	^ self result! !

!SmagickTransformation methodsFor: 'private-asserting' stamp: 'SR 5/8/2008 11:18'!
assertFileExistence: aFile
	| file |
	file := aFile last = $] ifTrue: [ aFile copyUpToLast: $[ ] ifFalse: [ aFile ].
	super assertFileExistence: file! !

!SmagickTransformation methodsFor: 'private' stamp: 'SR 9/9/2007 12:34'!
basicExecute
	^ self environment processor new 
		model: self;
		command: #command;
		streamTarget: self target;
		parser: #parse:;
		execute;
		yourself! !

!SmagickTransformation methodsFor: 'accessing-constants' stamp: 'SR 8/4/2007 09:17'!
channelConstants
	^ self constants: 'color channels'! !

!SmagickTransformation methodsFor: 'accessing' stamp: 'SR 8/10/2007 12:48'!
command
	^ String streamContents: [ :stream | stream 
		nextPutAll: (self environment commandFor: self class); space;
		nextPutAll: self preOptions; space;
		nextPutAll: self options; space;
		nextPutAll: self postOptions; space ]! !

!SmagickTransformation methodsFor: 'accessing-operators' stamp: 'SR 8/4/2007 11:29'!
compositionOperators
	^ self operatorSelectors
		collect: [ :sel | self operators perform: sel ]! !

!SmagickTransformation methodsFor: 'accessing-constants' stamp: 'SR 8/4/2007 09:11'!
constants
	^ SmagickConstants! !

!SmagickTransformation methodsFor: 'private' stamp: 'SR 8/4/2007 09:16'!
constants: aCategory
	^ (self constantsSelectors: aCategory)
		collect: [ :each | self constants perform: each ]! !

!SmagickTransformation methodsFor: 'private' stamp: 'SR 8/4/2007 09:16'!
constantsSelectors: aCategory
	^ self constants organization listAtCategoryNamed: aCategory! !

!SmagickTransformation methodsFor: 'image processing' stamp: 'SR 2/12/2008 15:31'!
do: aBlock if: aBoolean
	self do: aBlock if: aBoolean else: []! !

!SmagickTransformation methodsFor: 'image processing' stamp: 'SR 2/12/2008 15:32'!
do: aBlock if: aBoolean else: anotherBlock
	aBoolean 
		ifTrue: [ aBlock valueWithPossibleArgument: self ]
		ifFalse: [ anotherBlock valueWithPossibleArgument: self ] ! !

!SmagickTransformation methodsFor: 'private' stamp: 'SR 8/11/2007 00:49'!
emptyFlags
	^ ReadWriteStream with: String new! !

!SmagickTransformation methodsFor: 'private' stamp: 'SR 5/7/2008 12:51'!
exception: aProcessor
	(aProcessor errorString asLowercase includesSubstring: 'unrecognized option' caseSensitive: false)
		ifTrue: [ ^ SmagickUnrecognizedOption signalFor: self with: aProcessor ].
		
	(aProcessor errorString asLowercase includesSubstring: 'insufficient image data' caseSensitive: false)
		ifTrue: [ ^ SmagickInsufficientDataException signalFor: self with: aProcessor ].
		
	^ SmagickTransformationException signalFor: self with: aProcessor! !

!SmagickTransformation methodsFor: 'private' stamp: 'SR 9/9/2007 12:52'!
execute
	| processor |
	^ (processor := self basicExecute) succeeded
		ifTrue: [ processor ]
		ifFalse: [ self exception: processor ]! !

!SmagickTransformation methodsFor: 'private-formating' stamp: 'SR 8/11/2007 00:49'!
flags
	^ flags ifNil: [ self resetFlags ]! !

!SmagickTransformation methodsFor: 'private-formating' stamp: 'SR 8/10/2007 22:54'!
limit: aSymbol to: anInteger
	self 
		put: ('-', aSymbol asString) 
		with: anInteger! !

!SmagickTransformation methodsFor: 'image processing' stamp: 'SR 8/10/2007 22:59'!
limitDiskUsageTo: anInteger
	" image magic will fail if not enough disk is available "
	" default: unlimited "
	self limit: #disk to: anInteger! !

!SmagickTransformation methodsFor: 'accessing' stamp: 'SR 8/10/2007 13:16'!
name
	^ self class command ! !

!SmagickTransformation methodsFor: 'private' stamp: 'SR 8/4/2007 11:29'!
operatorSelectors
	^ self operators class selectors! !

!SmagickTransformation methodsFor: 'accessing-operators' stamp: 'SR 8/4/2007 11:13'!
operators
	^ SmagickCompositionOperators! !

!SmagickTransformation methodsFor: 'private-formating' stamp: 'SR 7/9/2007 23:26'!
options
	^ self flags contents! !

!SmagickTransformation methodsFor: 'private-parsing' stamp: 'SR 8/22/2007 23:54'!
parse: anImageIO
	^  (anImageIO executed and: [ anImageIO succeeded ])
		ifTrue: [ self parse: anImageIO outputString for: anImageIO process ]
		ifFalse: [ nil ]! !

!SmagickTransformation methodsFor: 'private-parsing' stamp: 'SR 8/11/2007 00:33'!
parse: aStream for: aProcess
	^ Dictionary new! !

!SmagickTransformation methodsFor: 'private-formating' stamp: 'SR 7/9/2007 13:27'!
postOptions
	^ ''! !

!SmagickTransformation methodsFor: 'private-formating' stamp: 'SR 7/9/2007 13:27'!
preOptions
	^ ''! !

!SmagickTransformation methodsFor: 'printing' stamp: 'SR 6/30/2007 22:36'!
printOn: aStream
	aStream nextPutAll: self command! !

!SmagickTransformation methodsFor: 'private-formating' stamp: 'SR 7/9/2007 23:54'!
put: aString
	self flags space; nextPutAll: aString! !

!SmagickTransformation methodsFor: 'private-formating' stamp: 'SR 6/30/2007 22:04'!
put: aCommand with: aValue
	self put: aCommand with: aValue postfix: ''! !

!SmagickTransformation methodsFor: 'private-formating' stamp: 'SR 6/30/2007 22:15'!
put: aCommand with: aValue postfix: aString
	aValue isNil not ifTrue: [ 
		self put: aCommand asString;
			put: (aValue asString, aString) ]! !

!SmagickTransformation methodsFor: 'private' stamp: 'SR 8/11/2007 00:49'!
resetFlags
	^ flags := self emptyFlags! !

!SmagickTransformation methodsFor: 'private' stamp: 'SR 8/11/2007 00:32'!
result
	^ self execute result 
		ifNotNilDo: [ :dictionary | self smagick on: self to with: dictionary ]! !

!SmagickTransformation methodsFor: 'private' stamp: 'SR 8/11/2007 00:01'!
target
	^ #to! !

!SmagickTransformation methodsFor: 'image processing' stamp: 'SR 8/10/2007 22:58'!
tryLimitMappingsTo: anInteger
	" default: 4096 mb "
	self limit: #map to: anInteger! !

!SmagickTransformation methodsFor: 'image processing' stamp: 'SR 8/10/2007 22:58'!
tryLimitMemoryUsageTo: anInteger
	" default: 1024 mb "
	self limit: #memory to: anInteger! !

!SmagickTransformation methodsFor: 'image processing' stamp: 'SR 8/10/2007 22:58'!
tryLimitOpenFilesTo: anInteger
	" default: 768 "
	self limit: #file to: anInteger! !

Object subclass: #SmagickCanvas
	instanceVariableNames: 'converter image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Drawing'!

!SmagickCanvas methodsFor: 'image accessing' stamp: 'SR 8/12/2007 12:03'!
add: aPrimitive
	self converter primitive: aPrimitive! !

!SmagickCanvas methodsFor: 'image accessing' stamp: 'SR 8/12/2007 12:05'!
add: aPrimitive with: aBlock
	aBlock valueWithPossibleArgument: aPrimitive.
	self add: aPrimitive! !

!SmagickCanvas methodsFor: 'private' stamp: 'SR 8/12/2007 11:57'!
arc
	^ (SmagickArc new)
		canvas: self;
		yourself! !

!SmagickCanvas methodsFor: 'image primitives' stamp: 'SR 8/12/2007 11:56'!
arcFrom: aPoint to: anotherPoint arcStart: anInteger arcStop: anotherInteger
	self arcFrom: aPoint to: anotherPoint arcStart: anInteger arcStop: anotherInteger with: [ ]! !

!SmagickCanvas methodsFor: 'image primitives' stamp: 'SR 8/12/2007 12:04'!
arcFrom: aPoint to: anotherPoint arcStart: anInteger arcStop: anotherInteger with: aBlock
	self add: (self arc
		from: aPoint
		to: anotherPoint;
		arcStart: anInteger;
		arcStop: anotherInteger;
		yourself) with: aBlock! !

!SmagickCanvas methodsFor: 'private' stamp: 'SR 8/12/2007 11:49'!
bezier
	^ (SmagickBezier new)
		canvas: self;
		yourself! !

!SmagickCanvas methodsFor: 'image primitives' stamp: 'SR 8/12/2007 11:50'!
bezier: aCollection
	self bezier: aCollection with: [ ]! !

!SmagickCanvas methodsFor: 'image primitives' stamp: 'SR 8/12/2007 12:04'!
bezier: aCollection with: aBlock
	self add: (self bezier points: aCollection; yourself) with: aBlock! !

!SmagickCanvas methodsFor: 'image properties' stamp: 'SR 8/25/2007 12:30'!
boundigBox
	^ self image boundingBox! !

!SmagickCanvas methodsFor: 'private' stamp: 'SR 8/12/2007 11:48'!
circle
	^ SmagickCircle new
		canvas: self;
		yourself! !

!SmagickCanvas methodsFor: 'image primitives' stamp: 'SR 8/11/2007 20:10'!
circle: aPoint edge: anotherPoint
	self circle: aPoint edge: anotherPoint with: [ ]! !

!SmagickCanvas methodsFor: 'image primitives' stamp: 'SR 8/12/2007 12:04'!
circle: aPoint edge: anotherPoint with: aBlock
	" this will draw a circle with the center aPoint and the edge using anotherPoint "
	self add: (self circle 
		center: aPoint; 
		edge: anotherPoint; 
		yourself) with: aBlock! !

!SmagickCanvas methodsFor: 'image primitives' stamp: 'SR 8/11/2007 20:11'!
circle: aPoint radius: anInteger
	self circle: aPoint radius: anInteger with: [ ]! !

!SmagickCanvas methodsFor: 'image primitives' stamp: 'SR 8/11/2007 20:14'!
circle: aPoint radius: anInteger with: aBlock
	" this will draw a circle with the center aPoint and a radius of anInteger pixels "
	self circle: aPoint edge: (aPoint x + anInteger @ aPoint y + anInteger) with: aBlock! !

!SmagickCanvas methodsFor: 'image primitives' stamp: 'SR 8/11/2007 20:14'!
circleFrom: aPoint to: anotherPoint
	self circleFrom: aPoint to: anotherPoint with: [ ]! !

!SmagickCanvas methodsFor: 'image primitives' stamp: 'SR 8/11/2007 20:22'!
circleFrom: aPoint to: anotherPoint with: aBlock
	" this will draw a circle within the bounding box with top left aPoint and bottom right anotherPoint "
	self
		circle: (((anotherPoint x - aPoint x) / 2) asFloat @ ((anotherPoint y - aPoint y) / 2) asFloat)
		edge: (aPoint x @ ((anotherPoint y - aPoint y) / 2) asFloat)
		with: aBlock! !

!SmagickCanvas methodsFor: 'accessing' stamp: 'SR 8/11/2007 18:16'!
converter
	^ converter! !

!SmagickCanvas methodsFor: 'accessing' stamp: 'SR 8/11/2007 18:16'!
converter: aConverter
	converter := aConverter! !

!SmagickCanvas methodsFor: 'private' stamp: 'nl 1/16/2008 12:13'!
drawImage
	^ (SmagickDrawImage new)
		canvas: self;
		yourself! !

!SmagickCanvas methodsFor: 'image draw' stamp: 'nl 1/16/2008 15:13'!
drawImage: aFile with: aBlock
	| canvas |
	canvas := self drawImage.
	canvas image: aFile. 
	self add: canvas with: aBlock! !

!SmagickCanvas methodsFor: 'private' stamp: 'SR 2/13/2008 13:57'!
ellipse
	^ SmagickEllipse new
		canvas: self;
		yourself! !

!SmagickCanvas methodsFor: 'image primitives' stamp: 'SR 8/12/2007 11:58'!
ellipse: aPoint xRadius: anInteger yRadius: anotherInteger
	self ellipse: aPoint xRadius: anInteger yRadius: anotherInteger with: [ ]! !

!SmagickCanvas methodsFor: 'image primitives' stamp: 'SR 8/12/2007 12:00'!
ellipse: aPoint xRadius: anInteger yRadius: anInteger2 arcStart: anInteger3 arcStop: anInteger4
	self ellipse: aPoint xRadius: anInteger yRadius: anInteger2 arcStart: anInteger3 arcStop: anInteger4 with: [ ]! !

!SmagickCanvas methodsFor: 'image primitives' stamp: 'SR 8/12/2007 12:04'!
ellipse: aPoint xRadius: anInteger yRadius: anInteger2 arcStart: anInteger3 arcStop: anInteger4 with: aBlock
	self add: (self ellipse
		center: aPoint;
		xRadius: anInteger;
		yRadius: anInteger2;
		arcStart: anInteger3;
		arcStop: anInteger4;
		yourself) with: aBlock! !

!SmagickCanvas methodsFor: 'image primitives' stamp: 'SR 8/12/2007 12:01'!
ellipse: aPoint xRadius: anInteger yRadius: anotherInteger with: aBlock
	self ellipse: aPoint xRadius: anInteger yRadius: anotherInteger arcStart: nil arcStop: nil with: aBlock! !

!SmagickCanvas methodsFor: 'image properties' stamp: 'SR 8/25/2007 12:28'!
extent
	^ self image extent! !

!SmagickCanvas methodsFor: 'image properties' stamp: 'SR 8/25/2007 12:28'!
geometry
	^ self image geometry! !

!SmagickCanvas methodsFor: 'image properties' stamp: 'SR 8/25/2007 12:28'!
height
	^ self image width! !

!SmagickCanvas methodsFor: 'private' stamp: 'SR 8/27/2007 09:18'!
image
	^ image ifNil: [ image := self converter asSmagickImage ]! !

!SmagickCanvas methodsFor: 'private' stamp: 'SR 8/12/2007 11:48'!
line
	^ SmagickLine new
		canvas: self;
		yourself! !

!SmagickCanvas methodsFor: 'image primitives' stamp: 'SR 8/11/2007 19:54'!
lineFrom: aPoint to: anotherPoint
	self lineFrom: aPoint to: anotherPoint with: [ ]! !

!SmagickCanvas methodsFor: 'image primitives' stamp: 'SR 8/12/2007 12:04'!
lineFrom: aPoint to: anotherPoint with: aBlock
	self add: (self line 
		from: aPoint; 
		to: anotherPoint; 
		yourself) with: aBlock! !

!SmagickCanvas methodsFor: 'image properties' stamp: 'SR 8/25/2007 12:29'!
pageGeometry
	^ self image pageGeometry! !

!SmagickCanvas methodsFor: 'private' stamp: 'SR 8/12/2007 11:48'!
point
	^ SmagickPoint new
		canvas: self;
		yourself! !

!SmagickCanvas methodsFor: 'image primitives' stamp: 'SR 8/12/2007 11:47'!
point: aPoint
	self point: aPoint with: [ ]! !

!SmagickCanvas methodsFor: 'image primitives' stamp: 'SR 8/12/2007 12:04'!
point: aPoint with: aBlock
	self add: (self point point: aPoint; yourself) with: aBlock! !

!SmagickCanvas methodsFor: 'private' stamp: 'SR 8/12/2007 11:49'!
polygon
	^ (SmagickPolygon new)
		canvas: self;
		yourself! !

!SmagickCanvas methodsFor: 'image primitives' stamp: 'SR 8/12/2007 11:50'!
polygon: aCollection
	self polygon: aCollection with: [ ]! !

!SmagickCanvas methodsFor: 'image primitives' stamp: 'SR 8/12/2007 12:04'!
polygon: aCollection with: aBlock
	self add: (self polygon points: aCollection; yourself) with: aBlock! !

!SmagickCanvas methodsFor: 'private' stamp: 'SR 8/12/2007 11:49'!
polyline
	^ (SmagickPolyline new)
		canvas: self;
		yourself! !

!SmagickCanvas methodsFor: 'image primitives' stamp: 'SR 8/12/2007 11:51'!
polyline: aCollection
	self polyline: aCollection with: [ ]! !

!SmagickCanvas methodsFor: 'image primitives' stamp: 'SR 8/12/2007 12:04'!
polyline: aCollection with: aBlock
	self add: (self polyline points: aCollection; yourself) with: aBlock! !

!SmagickCanvas methodsFor: 'private' stamp: 'SR 8/25/2007 12:31'!
properties
	^ self converter asSmagickImage properties! !

!SmagickCanvas methodsFor: 'image properties' stamp: 'SR 8/25/2007 12:30'!
quantumDepth
	^ self image quantumDepth ! !

!SmagickCanvas methodsFor: 'private' stamp: 'SR 8/12/2007 11:48'!
rectangle
	^ SmagickRectangle new
		canvas: self;
		yourself! !

!SmagickCanvas methodsFor: 'image primitives' stamp: 'SR 8/11/2007 19:53'!
rectangleFrom: aPoint to: anotherPoint
	self rectangleFrom: aPoint to: anotherPoint with: [ ]! !

!SmagickCanvas methodsFor: 'image primitives' stamp: 'SR 8/12/2007 12:04'!
rectangleFrom: aPoint to: anotherPoint with: aBlock
	self add: (self rectangle 
		from: aPoint; 
		to: anotherPoint; 
		yourself) with: aBlock! !

!SmagickCanvas methodsFor: 'private' stamp: 'SR 8/12/2007 11:54'!
roundRectangle
	^ SmagickRoundRectangle new
		canvas: self;
		yourself! !

!SmagickCanvas methodsFor: 'image primitives' stamp: 'SR 8/12/2007 11:54'!
roundRectangleFrom: aPoint to: anotherPoint cornerWidth: anInteger cornerHeight: anotherInteger
	self roundRectangleFrom: aPoint to: anotherPoint cornerWidth: anInteger cornerHeight: anotherInteger with: [ ]! !

!SmagickCanvas methodsFor: 'image primitives' stamp: 'SR 8/12/2007 12:04'!
roundRectangleFrom: aPoint to: anotherPoint cornerWidth: anInteger cornerHeight: anotherInteger with: aBlock
	self add: (self roundRectangle
		from: aPoint;
		to: anotherPoint;
		cornerWidth: anInteger;
		cornerHeight: anotherInteger;
		yourself) with: aBlock! !

!SmagickCanvas methodsFor: 'private' stamp: 'SR 8/26/2007 15:16'!
text
	^ (SmagickText new)
		canvas: self;
		yourself! !

!SmagickCanvas methodsFor: 'image text' stamp: 'SR 9/1/2007 13:27'!
text: aString font: aFont size: anInteger at: aPoint with: aBlock
	self add: (self text
		text: aString;
		at: aPoint;
		font: aFont;
		size: anInteger;
		yourself) with: aBlock! !

!SmagickCanvas methodsFor: 'image properties' stamp: 'SR 8/25/2007 12:30'!
uniqueColors
	^ self image uniqueColors ! !

!SmagickCanvas methodsFor: 'image properties' stamp: 'SR 8/25/2007 12:29'!
xResolution
	^ self image xResolution ! !

!SmagickCanvas methodsFor: 'image properties' stamp: 'SR 8/25/2007 12:29'!
yResolution
	^ self image yResolution ! !

Object subclass: #SmagickCompositionOperators
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Globals'!

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
add
	^ 'Add'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
atop
	^ 'Atop'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
blend
	^ 'Blend'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
bumpmap
	^ 'Bumpmap'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
changeMask
	^ 'ChangeMask'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
clear
	^ 'Clear'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
colorBurn
	^ 'ColorBurn'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
colorDodge
	^ 'ColorDodge'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
colorize
	^ 'Colorize'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
copyBlack
	^ 'CopyBlack'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
copyBlue
	^ 'CopyBlue'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:28'!
copyCopy
	" we cannot define copy as a method "
	^ 'Copy'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
copyCyan
	^ 'CopyCyan'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
copyGreen
	^ 'CopyGreen'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
copyMagenta
	^ 'CopyMagenta'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
copyOpacity
	^ 'CopyOpacity'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
copyRed
	^ 'CopyRed'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
copyYellow
	^ 'CopyYellow'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
darken
	^ 'Darken'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
difference
	^ 'Difference'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
displace
	^ 'Displace'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
dissolve
	^ 'Dissolve'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
dst
	^ 'Dst'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
dstAtop
	^ 'DstAtop'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
dstIn
	^ 'DstIn'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
dstOut
	^ 'DstOut'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
dstOver
	^ 'DstOver'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
exclusion
	^ 'Exclusion'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
hardLight
	^ 'HardLight'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
hue
	^ 'Hue'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
in
	^ 'In'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
lighten
	^ 'Lighten'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
luminize
	^ 'Luminize'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
minus
	^ 'Minus'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
modulate
	^ 'Modulate'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
multiply
	^ 'Multiply'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
none
	^ 'None'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
out
	^ 'Out'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
over
	^ 'Over'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
overlay
	^ 'Overlay'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
plus
	^ 'Plus'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
replace
	^ 'Replace'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
saturate
	^ 'Saturate'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
screen
	^ 'Screen'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
softLight
	^ 'SoftLight'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
src
	^ 'Src'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
srcAtop
	^ 'SrcAtop'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
srcIn
	^ 'SrcIn'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
srcOut
	^ 'SrcOut'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
srcOver
	^ 'SrcOver'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
subtract
	^ 'Subtract'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
threshold
	^ 'Threshold'! !

!SmagickCompositionOperators class methodsFor: 'composition operators' stamp: 'SR 8/4/2007 11:27'!
xor
	^ 'Xor'! !

Object subclass: #SmagickConstants
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Globals'!

!SmagickConstants class methodsFor: 'color channels' stamp: 'SR 8/4/2007 08:58'!
alpha
	^ 'Alpha'! !

!SmagickConstants class methodsFor: 'color types' stamp: 'SR 7/2/2007 12:27'!
bilevel
	^ 'Bilevel'! !

!SmagickConstants class methodsFor: 'color channels' stamp: 'SR 8/4/2007 08:58'!
black
	^ 'Black'! !

!SmagickConstants class methodsFor: 'color channels' stamp: 'SR 8/4/2007 08:57'!
blue
	^ 'Blue'! !

!SmagickConstants class methodsFor: 'compression types' stamp: 'SR 7/2/2007 12:45'!
bzip
	^ 'BZip'! !

!SmagickConstants class methodsFor: 'color channels' stamp: 'SR 8/4/2007 08:59'!
cmyk
	^ 'CMYK'! !

!SmagickConstants class methodsFor: 'color channels' stamp: 'SR 8/4/2007 08:59'!
cmyka
	^ 'CMYKA'! !

!SmagickConstants class methodsFor: 'color types' stamp: 'SR 7/2/2007 12:41'!
colorSeparation
	^ 'ColorSeparation'! !

!SmagickConstants class methodsFor: 'color types' stamp: 'SR 7/2/2007 12:41'!
colorSeparationMatte
	^ 'ColorSeparationMatte'! !

!SmagickConstants class methodsFor: 'resize filter types' stamp: 'SR 7/2/2007 13:15'!
cubic
	^ 'Cubic'! !

!SmagickConstants class methodsFor: 'color channels' stamp: 'SR 8/4/2007 08:58'!
cyan
	^ 'Cyan'! !

!SmagickConstants class methodsFor: 'resize filter types' stamp: 'SR 7/2/2007 13:16'!
gaussian
	^ 'Gaussian'! !

!SmagickConstants class methodsFor: 'color types' stamp: 'SR 7/2/2007 12:26'!
grayscale
	^ 'Grayscale'! !

!SmagickConstants class methodsFor: 'color channels' stamp: 'SR 8/4/2007 08:58'!
green
	^ 'Green'! !

!SmagickConstants class methodsFor: 'compression types' stamp: 'SR 7/2/2007 12:45'!
group4
	^ 'Group4'! !

!SmagickConstants class methodsFor: 'resize filter types' stamp: 'SR 7/2/2007 13:15'!
hamming
	^ 'Hamming'! !

!SmagickConstants class methodsFor: 'color channels' stamp: 'SR 8/4/2007 08:59'!
index
	^ 'Index'! !

!SmagickConstants class methodsFor: 'compression types' stamp: 'SR 7/2/2007 12:45'!
jpeg
	^ 'JPEG'! !

!SmagickConstants class methodsFor: 'compression types' stamp: 'SR 7/2/2007 12:45'!
jpeg2000
	^ 'JPEG2000'! !

!SmagickConstants class methodsFor: 'resize filter types' stamp: 'SR 7/2/2007 13:15'!
lanczos
	^ 'Lanczos'! !

!SmagickConstants class methodsFor: 'compression types' stamp: 'SR 7/2/2007 12:44'!
lossless
	^ 'Lossless'! !

!SmagickConstants class methodsFor: 'compression types' stamp: 'SR 7/2/2007 12:45'!
lzw
	^ 'LZW'! !

!SmagickConstants class methodsFor: 'color channels' stamp: 'SR 8/4/2007 08:59'!
magenta
	^ 'Magenta'! !

!SmagickConstants class methodsFor: 'compression types' stamp: 'SR 7/2/2007 12:44'!
none
	^ 'None'! !

!SmagickConstants class methodsFor: 'color channels' stamp: 'SR 8/4/2007 08:58'!
opacity
	^ 'Opacity'! !

!SmagickConstants class methodsFor: 'color types' stamp: 'SR 7/2/2007 12:27'!
optimizedColor
	^ 'Optimize'! !

!SmagickConstants class methodsFor: 'color types' stamp: 'SR 7/2/2007 12:41'!
palette
	^ 'palette'! !

!SmagickConstants class methodsFor: 'color types' stamp: 'SR 7/2/2007 12:29'!
paletteMatte
	^ 'PaletteMatte'! !

!SmagickConstants class methodsFor: 'resize filter types' stamp: 'SR 7/2/2007 13:15'!
quadratic
	^ 'Quadratic'! !

!SmagickConstants class methodsFor: 'color channels' stamp: 'SR 8/4/2007 08:57'!
red
	^ 'Red'! !

!SmagickConstants class methodsFor: 'color channels' stamp: 'SR 8/4/2007 08:59'!
rgb
	^ 'RGB'! !

!SmagickConstants class methodsFor: 'color channels' stamp: 'SR 8/4/2007 08:59'!
rgba
	^ 'RGBA'! !

!SmagickConstants class methodsFor: 'compression types' stamp: 'SR 7/2/2007 12:45'!
rle
	^ 'RLE'! !

!SmagickConstants class methodsFor: 'color types' stamp: 'SR 7/2/2007 12:27'!
trueColor
	^ 'TrueColor'! !

!SmagickConstants class methodsFor: 'color types' stamp: 'SR 7/2/2007 12:28'!
trueColorMatte
	^ 'TrueColorMatte'! !

!SmagickConstants class methodsFor: 'color channels' stamp: 'SR 8/4/2007 08:58'!
yellow
	^ 'Yellow'! !

!SmagickConstants class methodsFor: 'compression types' stamp: 'SR 7/2/2007 12:41'!
zip
	^ 'Zip'! !

Object subclass: #SmagickEnvironment
	instanceVariableNames: 'installationPath'
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'Smagick'!

!SmagickEnvironment class methodsFor: 'accessing' stamp: 'SR 7/15/2007 18:58'!
default
	" run <self setup> to create an environment interactively "
	^ Current ifNil: [ SmagickEnvironmentNotInitialized signal ]! !

!SmagickEnvironment class methodsFor: 'private-initialization' stamp: 'SR 9/7/2007 18:20'!
finishSetup: anEnvironment
	(anEnvironment unsupportedFormats: #(jpg jpeg png bmp gif pdf ps tiff wmf))
		ifNotEmptyDo: [ :col | self notifyUnsupportedFormats: col ]
		ifEmpty: [ self inform: 'Your ImageMagick environment seems to be OK ... have fun !!' ]! !

!SmagickEnvironment class methodsFor: 'private-initialization' stamp: 'SR 9/7/2007 18:21'!
notifyUnsupportedFormats: aCollection
	aCollection isEmpty ifTrue: [ ^ self ].
	self inform: (String streamContents: [ :stream |
		stream nextPutAll: 'The following common formats will not work on your system ... '; cr.
		aCollection 
			do: [ :each | stream nextPutAll: each ] separatedBy: [ stream nextPutAll: ','; space ].
		stream cr; nextPutAll: 'You need to install those libraries/delegates and recompile ImageMagick in order to use them !!' ])! !

!SmagickEnvironment class methodsFor: 'accessing' stamp: 'SR 9/7/2007 18:19'!
processor
	^ OSProcessParsedIO! !

!SmagickEnvironment class methodsFor: 'private-initialization' stamp: 'SR 7/10/2007 00:02'!
requestConfirmation: aPath
	^ OBConfirmationRequest 
		prompt: '', aPath, ''' does not point to a valid ImageMagick installation. Try again ?'
		confirm: 'yes'
		cancel: 'no'! !

!SmagickEnvironment class methodsFor: 'private-initialization' stamp: 'SR 9/7/2007 18:21'!
requestText
	^ OBTextRequest 
		prompt: 'Enter the PATH to your ImageMagick installation' 
		template: (Current 
			ifNotNilDo: [ :env | env installationPath ] 
			ifNil: [ '/usr/local/imagemagick/bin' ])! !

!SmagickEnvironment class methodsFor: 'accessing' stamp: 'SR 8/11/2007 18:38'!
root
	^ SmagickTransformation! !

!SmagickEnvironment class methodsFor: 'initialization' stamp: 'SR 9/7/2007 18:21'!
setup
	" setup smagick interactively "
	(self requestText ifNotNilDo: [ :path | self setup: path ])
		ifNotNilDo: [ :env | self finishSetup: env ]! !

!SmagickEnvironment class methodsFor: 'private-initialization' stamp: 'SR 7/15/2007 00:11'!
setup: aPath
	^ (self validate: aPath)
		ifTrue: [ Current := self new installationPath: aPath ]
		ifFalse: [ (self requestConfirmation: aPath) ifTrue: [ self setup ] ]! !

!SmagickEnvironment class methodsFor: 'initialization' stamp: 'SR 9/7/2007 18:22'!
setupSilent: aPath
	" make a silent installation, smagick will not work if the path is invalid "
	" no exception or dialogs "
	^ Current := self new installationPath: aPath! !

!SmagickEnvironment class methodsFor: 'accessing' stamp: 'SR 9/7/2007 18:23'!
streamClass
	^ StandardFileStream ! !

!SmagickEnvironment class methodsFor: 'accessing' stamp: 'SR 8/10/2007 12:38'!
tools
	^ self root tools! !

!SmagickEnvironment class methodsFor: 'private-initialization' stamp: 'SR 9/7/2007 18:19'!
validate: aPath
	| directory |
	^ (directory := FileDirectory on: aPath) exists
		and: [ self root tools anySatisfy: [ :each | directory fileExists: (self processor executableFor: each command) ] ]! !

!SmagickEnvironment methodsFor: 'testing' stamp: 'SR 8/10/2007 20:16'!
canRead: aString
	^ self canReadAll: (Array with: aString)! !

!SmagickEnvironment methodsFor: 'testing' stamp: 'SR 8/5/2007 11:22'!
canReadAll: aCollection
	^ (self modulesForAll: (self preprocess: aCollection))
		allSatisfy: [ :assoc | 
			(assoc value select: [ :each | each canRead ]) isEmpty not ]
! !

!SmagickEnvironment methodsFor: 'testing' stamp: 'SR 8/5/2007 11:16'!
canWrite: aString
	^ self canWriteAll: (Array with: aString)! !

!SmagickEnvironment methodsFor: 'testing' stamp: 'SR 8/5/2007 11:22'!
canWriteAll: aCollection
	^ (self modulesForAll: (self preprocess: aCollection))
		allSatisfy: [ :assoc | 
			(assoc value select: [ :each | each canWrite ]) isEmpty not ]! !

!SmagickEnvironment methodsFor: 'accessing-dynamic' stamp: 'SR 9/1/2007 14:42'!
channels
	^ self rawProcessor new
		command: (self commandList: 'channel');
		parser: [ :io | self parseChannels: io ];
		result! !

!SmagickEnvironment methodsFor: 'accessing-dynamic' stamp: 'SR 9/9/2007 12:42'!
commandFor: aTool
	^ (String streamContents: [ :stream |
		stream nextPutAll: self installationPath.
		self installationPath last = FileDirectory pathNameDelimiter
			ifFalse: [ stream nextPut: FileDirectory pathNameDelimiter ].
		stream nextPutAll: (self processor executableFor: aTool) ]) doubleQuoted! !

!SmagickEnvironment methodsFor: 'private' stamp: 'SR 9/9/2007 12:44'!
commandList: aString
	^ String streamContents: [ :stream | stream
		nextPutAll: (self commandFor: self root identifier); space;
		nextPutAll: '-list'; space;
		nextPutAll: aString ]! !

!SmagickEnvironment methodsFor: 'private' stamp: 'SR 9/1/2007 13:38'!
commandName: aString
	^ String streamContents: [ :stream |
		stream 
			nextPutAll: FileDirectory default pathName;
			nextPut: FileDirectory pathNameDelimiter;
			nextPutAll: aString ]! !

!SmagickEnvironment methodsFor: 'accessing-dynamic' stamp: 'SR 9/1/2007 14:18'!
fontFamilies
	| tmp |
	tmp := Dictionary new.
	self fonts do: [ :each |
		(tmp at: each family ifAbsentPut: [ SmagickFontFamily new ]) add: each ].
	^ SmagickCollection withAll: tmp values! !

!SmagickEnvironment methodsFor: 'accessing-dynamic' stamp: 'SR 9/1/2007 14:42'!
fonts
	^ self rawProcessor new
		command: (self commandList: 'type');
		parser: [ :io | self parseFonts: io ];
		result! !

!SmagickEnvironment methodsFor: 'accessing' stamp: 'SR 7/14/2007 14:46'!
installationPath
	^ installationPath! !

!SmagickEnvironment methodsFor: 'accessing' stamp: 'SR 7/14/2007 14:48'!
installationPath: aPath
	installationPath := aPath! !

!SmagickEnvironment methodsFor: 'accessing-dynamic' stamp: 'SR 9/1/2007 14:44'!
modules
	^ self rawProcessor new
		command: (self commandList: 'format');
		parser: [ :io | self parseModules: io ];
		result! !

!SmagickEnvironment methodsFor: 'private' stamp: 'SR 9/1/2007 14:20'!
modulesFor: aString
	^ aString -> (self modules select: [ :each | each matches: aString ])! !

!SmagickEnvironment methodsFor: 'private' stamp: 'SR 9/1/2007 14:19'!
modulesForAll: aCollection
	| modules |
	modules := self modules.
	^ ((self preprocess: aCollection) collect: [ :string | 
		string -> (modules select: [ :mod | mod matches: string ]) ])! !

!SmagickEnvironment methodsFor: 'private' stamp: 'SR 9/1/2007 14:27'!
parseChannels: anImageIO
	^ SmagickCollection withAll: (anImageIO outputString subStrings: String crlf)! !

!SmagickEnvironment methodsFor: 'private' stamp: 'SR 9/1/2007 13:47'!
parseFont: aCollection
	^ SmagickFont new
		name: aCollection first;
		family: aCollection second;
		style: aCollection third;
		stretch: aCollection fourth;
		weight: aCollection fifth;
		yourself! !

!SmagickEnvironment methodsFor: 'private' stamp: 'SR 2/13/2008 13:43'!
parseFonts: anImageIO
	< lint: #expect rule: #longMethods rational: 'parsing fonts is complex'>
	| fonts rawFonts rawTokens |
	" initialize parser "
	fonts := SmagickCollection new.
	rawFonts := (anImageIO outputString subStrings: String crlf).
	rawFonts size < 3 ifTrue: [ ^ fonts ].
	
	" get rid of the header and footer "
	rawFonts := rawFonts copyFrom: 4 to: rawFonts size - 1. 
	
	" parde the body "
	rawFonts do: [ :line |
		rawTokens := line substrings.
		(self parseFont: rawTokens) 
				ifNotNilDo: [ :font | fonts add: font ] ].
	^ fonts! !

!SmagickEnvironment methodsFor: 'private' stamp: 'SR 8/5/2007 10:53'!
parseModule: aCollection
	^ ((aCollection first: 2) allSatisfy: [ :each | each asUppercase = each ])
		ifTrue: [ SmagickModule new
					name: aCollection second;
					format: (aCollection first copyReplaceAll: '*' with: '');
					read: (aCollection third first asLowercase = $r);
					write: (aCollection third second asLowercase = $w);
					multiImage: (aCollection third third = $+);
					nativeBlob: (aCollection first last = $*);
					yourself ]
		ifFalse: [ nil ]! !

!SmagickEnvironment methodsFor: 'private' stamp: 'SR 2/13/2008 13:43'!
parseModules: anImageIO
	< lint: #expect rule: #longMethods rational: 'parsing modules is complex'>
	| modules rawModules rawTokens |

	" initialize parser "
	modules := SmagickCollection new.
	rawModules := (anImageIO outputString subStrings: String crlf).
	rawModules size < 3 ifTrue: [ ^ modules ].
	
	" get rid of the header and footer "
	rawModules := rawModules copyFrom: 3 to: rawModules size - 1. 
	
	" parde the body "
	rawModules do: [ :line |
		rawTokens := line substrings.
		rawTokens := rawTokens copyFrom: 1 to: (3 min: rawTokens size).
		rawTokens size < 3 
			ifFalse: [ (self parseModule: rawTokens) 
				ifNotNilDo: [ :module | modules add: module ] ] ].
	^ modules! !

!SmagickEnvironment methodsFor: 'private' stamp: 'SR 8/5/2007 11:36'!
preprocess: aCollection
	^ aCollection collect: [ :each | self translate: each asLowercase ]! !

!SmagickEnvironment methodsFor: 'accessing' stamp: 'SR 9/7/2007 18:19'!
processor
	^ self class processor! !

!SmagickEnvironment methodsFor: 'private' stamp: 'SR 9/1/2007 14:35'!
rawProcessor
	^ OSProcessParsedRawIO! !

!SmagickEnvironment methodsFor: 'accessing-dynamic' stamp: 'SR 7/14/2007 14:57'!
root
	^ self class root! !

!SmagickEnvironment methodsFor: 'accessing' stamp: 'SR 9/7/2007 18:23'!
streamClass
	^ self class streamClass ! !

!SmagickEnvironment methodsFor: 'accessing-dynamic' stamp: 'SR 9/1/2007 14:22'!
supportedFormats: aCollection
	" select the list of supported formats from aCollection, eg. #(png #jpeg) "
	^ (self modulesForAll: (self preprocess: aCollection))
		select: [ :assoc | assoc value isEmpty not ]
		thenCollect: [ :assoc | assoc key ]! !

!SmagickEnvironment methodsFor: 'testing' stamp: 'SR 7/14/2007 23:38'!
supports: aString
	^ self supportsAll: (Array with: aString)! !

!SmagickEnvironment methodsFor: 'testing' stamp: 'SR 8/5/2007 11:22'!
supportsAll: aCollection
	^ ((self modulesForAll: (self preprocess: aCollection)) 
		detect: [ :assoc | assoc value isEmpty ]
		ifNone: [ nil ]) isNil! !

!SmagickEnvironment methodsFor: 'accessing-dynamic' stamp: 'SR 8/10/2007 12:54'!
tools
	^ self root tools! !

!SmagickEnvironment methodsFor: 'private' stamp: 'SR 2/13/2008 13:44'!
translate: aString
	< lint: #expect rule: #longMethods rational: 'translation tables are long'>
	" fix the alternative names of some image formats - some image-apps unfortunately append very strange extensions - image magick cannot map those names to the right formats - we try to remap them "
	aString = 'tif' ifTrue: [ ^ 'tiff' ].
	aString = 'pic' ifTrue: [ ^ 'pict' ].
	aString = 'picture' ifTrue: [ ^ 'pict' ].
	aString = 'xps' ifTrue: [ ^ 'eps' ].
	aString = 'shtm' ifTrue: [ ^ 'shtml' ].
	aString = 'htm' ifTrue: [ ^ 'html' ].
	(('jpe2*' match: aString) or: [ 'jpeg2*' match: aString ]) ifTrue: [ ^ 'jp2' ].
	aString = 'matlab' ifTrue: [ ^ 'mat' ].
	aString = 'thumb' ifTrue: [ ^ 'thumbnail' ].
	^ aString! !

!SmagickEnvironment methodsFor: 'accessing-dynamic' stamp: 'SR 9/1/2007 14:22'!
unsupportedFormats: aCollection
	" select the list of unsupported formats from aCollection, eg. #(doc #xsl) "
	^ (self modulesForAll: (self preprocess: aCollection))
		select: [ :assoc | assoc value isEmpty ]
		thenCollect: [ :assoc | assoc key ]! !

!SmagickEnvironment methodsFor: 'testing' stamp: 'SR 1/10/2008 09:33'!
validate
	^ self class validate: self installationPath ! !

Object subclass: #SmagickFont
	instanceVariableNames: 'family name stretch style weight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Utils'!

!SmagickFont methodsFor: 'accessing' stamp: 'SR 9/1/2007 13:40'!
family
	^family! !

!SmagickFont methodsFor: 'accessing' stamp: 'SR 9/1/2007 13:40'!
family: anObject
	family := anObject! !

!SmagickFont methodsFor: 'accessing' stamp: 'SR 9/1/2007 13:40'!
name
	^name! !

!SmagickFont methodsFor: 'accessing' stamp: 'SR 9/1/2007 13:40'!
name: anObject
	name := anObject! !

!SmagickFont methodsFor: 'printing' stamp: 'SR 9/1/2007 14:00'!
printOn: aStream
	aStream nextPutAll: self name; space;
		nextPut: $[;
		nextPutAll: self family;
		nextPut: $]! !

!SmagickFont methodsFor: 'accessing' stamp: 'SR 9/1/2007 13:40'!
stretch
	^stretch! !

!SmagickFont methodsFor: 'accessing' stamp: 'SR 9/1/2007 13:40'!
stretch: anObject
	stretch := anObject! !

!SmagickFont methodsFor: 'accessing' stamp: 'SR 9/1/2007 13:40'!
style
	^style! !

!SmagickFont methodsFor: 'accessing' stamp: 'SR 9/1/2007 13:40'!
style: anObject
	style := anObject! !

!SmagickFont methodsFor: 'accessing' stamp: 'SR 9/1/2007 13:40'!
weight
	^weight! !

!SmagickFont methodsFor: 'accessing' stamp: 'SR 9/1/2007 13:40'!
weight: anObject
	weight := anObject! !

Object subclass: #SmagickFormatProperty
	instanceVariableNames: 'symbol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Utils'!

!SmagickFormatProperty methodsFor: 'converting' stamp: 'SR 7/14/2007 14:31'!
asUniqueFormat
	^ self symbol asString! !

!SmagickFormatProperty methodsFor: 'private' stamp: 'SR 7/12/2007 23:20'!
parse: aCollection
	self subclassResponsibility! !

!SmagickFormatProperty methodsFor: 'printing' stamp: 'SR 7/12/2007 22:43'!
printOn: aStream
	aStream nextPutAll: self asUniqueFormat! !

!SmagickFormatProperty methodsFor: 'accessing' stamp: 'SR 7/12/2007 23:18'!
symbol
	^ symbol! !

!SmagickFormatProperty methodsFor: 'accessing' stamp: 'SR 7/12/2007 23:18'!
symbol: aString
	symbol := aString! !

SmagickFormatProperty subclass: #SmagickNaryFormatProperty
	instanceVariableNames: 'formats parsers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Utils'!

!SmagickNaryFormatProperty methodsFor: 'accessing' stamp: 'SR 7/12/2007 23:28'!
format
	^ self formats first! !

!SmagickNaryFormatProperty methodsFor: 'accessing' stamp: 'SR 7/12/2007 23:27'!
formats
	^ formats! !

!SmagickNaryFormatProperty methodsFor: 'accessing' stamp: 'SR 7/12/2007 23:27'!
formats: aCollection
	formats := aCollection! !

!SmagickNaryFormatProperty methodsFor: 'private' stamp: 'SR 7/14/2007 14:32'!
parse: aCollection
	^ (1 to: self formats size) collect: [ :index |
		(self formats at: index) -> ((aCollection at: index ifAbsent: [ nil ])
			ifNotNilDo: [ :val | (self parsers at: index) value: val]) ]! !

!SmagickNaryFormatProperty methodsFor: 'accessing' stamp: 'SR 7/12/2007 22:26'!
parsers
	^ parsers! !

!SmagickNaryFormatProperty methodsFor: 'accessing' stamp: 'SR 7/12/2007 22:26'!
parsers: aCollection
	parsers := aCollection! !

SmagickFormatProperty subclass: #SmagickUnaryFormatProperty
	instanceVariableNames: 'format parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Utils'!

!SmagickUnaryFormatProperty methodsFor: 'accessing' stamp: 'SR 7/12/2007 23:19'!
format
	^ format! !

!SmagickUnaryFormatProperty methodsFor: 'accessing' stamp: 'SR 7/12/2007 23:19'!
format: aSymbol
	format := aSymbol! !

!SmagickUnaryFormatProperty methodsFor: 'private' stamp: 'SR 7/14/2007 14:32'!
parse: aCollection
	^ Array with: (self format -> (self parser value: (aCollection at: 1 ifAbsent: [ nil ])))! !

!SmagickUnaryFormatProperty methodsFor: 'accessing' stamp: 'SR 7/9/2007 23:43'!
parser
	^ parser! !

!SmagickUnaryFormatProperty methodsFor: 'accessing' stamp: 'SR 7/9/2007 23:44'!
parser: aBlock
	parser := aBlock! !

Object subclass: #SmagickGeometry
	instanceVariableNames: 'height width xoffset yoffset qualifier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Utils'!

!SmagickGeometry class methodsFor: 'private' stamp: 'SR 2/13/2008 13:48'!
assert: aCollection and: anotherCollection
	" simple checks "
	((aCollection size >= 2 and: [ aCollection size <= 5]) 
		and: [ (anotherCollection notEmpty and: [ anotherCollection size <= 4 ]) ]
		and: [ anotherCollection asString matchesRegex: '^x([-+][-+])*[!!%<>]*$' ])
		ifFalse: [ SmagickInvalidGeometry signal ]! !

!SmagickGeometry class methodsFor: 'instance creation' stamp: 'SR 8/3/2007 16:28'!
from: aString
	" width x height (+/-) xoffset (+/-) y offset (%/!!/</>)"
	^ self 
		fromCollection: (aString withBlanksTrimmed subStrings: #( $x $+ $- $% $!! $< $> ))
		with: (aString reject: [ :each | each isDigit ])! !

!SmagickGeometry class methodsFor: 'instance creation' stamp: 'SR 8/3/2007 17:01'!
fromCollection: aCollection with: anotherCollection
	| instance |
	self assert: aCollection and: anotherCollection.
	instance := self new.
	self parse: aCollection and: anotherCollection widthAndHeigth: instance.
	self parse: aCollection and: anotherCollection offsets: instance.
	self parse: aCollection and: anotherCollection qualifier: instance.
	^ instance! !

!SmagickGeometry class methodsFor: 'private' stamp: 'SR 8/3/2007 16:35'!
parse: aCollection and: anotherCollection offsets: aSmagickGeometry
	aCollection size >= 4
		ifTrue: [ 
			aSmagickGeometry 
				xoffset: (aCollection third asNumber) * (self prefix: anotherCollection second);
				yoffset: (aCollection fourth asNumber) * (self prefix: anotherCollection third) ]! !

!SmagickGeometry class methodsFor: 'private' stamp: 'SR 8/3/2007 16:37'!
parse: aCollection and: anotherCollection qualifier: aSmagickGeometry
	anotherCollection size \\ 2 = 0
		ifTrue: [ aSmagickGeometry qualifier: anotherCollection last asCharacter ]! !

!SmagickGeometry class methodsFor: 'private' stamp: 'SR 8/3/2007 16:29'!
parse: aCollection and: anotherCollection widthAndHeigth: aSmagickGeometry
	aSmagickGeometry 
		width: aCollection first asNumber;
		height: aCollection second asNumber
	! !

!SmagickGeometry class methodsFor: 'private' stamp: 'SR 8/3/2007 15:56'!
parse: aCollection widthAndHeigth: aSmagickGeometry
	aSmagickGeometry 
		width: aCollection first asNumber;
		height: aCollection second asNumber
	! !

!SmagickGeometry class methodsFor: 'private' stamp: 'SR 8/3/2007 16:33'!
prefix: aCharacter
	^ aCharacter = $- 
		ifTrue: [ -1 ]
		ifFalse: [ 1 ]! !

!SmagickGeometry class methodsFor: 'accessing-defaults' stamp: 'SR 8/3/2007 17:07'!
qualifierExactly
	^ self qualifiers first! !

!SmagickGeometry class methodsFor: 'accessing-defaults' stamp: 'SR 8/3/2007 17:07'!
qualifierPercentage
	^ self qualifiers second! !

!SmagickGeometry class methodsFor: 'accessing-defaults' stamp: 'SR 8/3/2007 17:07'!
qualifierResizeIfGreater
	^ self qualifiers fourth! !

!SmagickGeometry class methodsFor: 'accessing-defaults' stamp: 'SR 8/3/2007 17:07'!
qualifierResizeIfSmaller
	^ self qualifiers third! !

!SmagickGeometry class methodsFor: 'accessing-defaults' stamp: 'SR 8/3/2007 17:08'!
qualifiers
	^ #( $!! $% $< $> )! !

!SmagickGeometry methodsFor: 'testing' stamp: 'SR 8/3/2007 16:52'!
= anObject
	^ self species = anObject species
		and: [ self width = anObject width 
			and: [ self height = anObject height 
				and: [ self xoffset  = anObject xoffset 
					and: [ self yoffset = anObject yoffset
						and: [ self qualifier = anObject qualifier ] ] ] ] ]! !

!SmagickGeometry methodsFor: 'converting' stamp: 'SR 8/3/2007 16:10'!
asForm
	^ Rectangle 
		origin: (0 @ 0)
		corner: (self extent + self offset)! !

!SmagickGeometry methodsFor: 'accessing-dynamic' stamp: 'SR 8/3/2007 17:09'!
beExactly
	self qualifier: self class qualifierExactly! !

!SmagickGeometry methodsFor: 'accessing-dynamic' stamp: 'SR 8/3/2007 16:04'!
beNormal
	self qualifier: nil! !

!SmagickGeometry methodsFor: 'accessing-dynamic' stamp: 'SR 8/3/2007 17:09'!
bePercentage
	self qualifier: self class qualifierPercentage! !

!SmagickGeometry methodsFor: 'accessing-dynamic' stamp: 'SR 8/3/2007 16:13'!
extent
	^ self width @ self height! !

!SmagickGeometry methodsFor: 'accessing' stamp: 'SR 8/3/2007 15:36'!
height
	^height ifNil: [ 0 ]! !

!SmagickGeometry methodsFor: 'accessing' stamp: 'SR 8/3/2007 15:31'!
height: anObject
	height := anObject! !

!SmagickGeometry methodsFor: 'accessing-dynamic' stamp: 'SR 8/3/2007 16:13'!
offset
	^ self xoffset @ self yoffset ! !

!SmagickGeometry methodsFor: 'printing' stamp: 'SR 8/3/2007 16:35'!
printOn: aStream
	aStream 
		nextPutAll: self width asString; 
		nextPut: $x;
		nextPutAll: self height asString;
		nextPut: (self xoffset >= 0 ifTrue: [ $+ ] ifFalse: [ $- ]);
		nextPutAll: self xoffset abs asString;
		nextPut: (self yoffset >= 0 ifTrue: [ $+ ] ifFalse: [ $- ]);
		nextPutAll: self yoffset abs asString;
		nextPutAll: (self qualifier asString ifNil: [ '' ])! !

!SmagickGeometry methodsFor: 'accessing' stamp: 'SR 8/3/2007 15:43'!
qualifier
	^ qualifier ifNil: [ Character space ]! !

!SmagickGeometry methodsFor: 'accessing' stamp: 'SR 8/3/2007 16:05'!
qualifier: aCharacter
	qualifier := aCharacter! !

!SmagickGeometry methodsFor: 'accessing-dynamic' stamp: 'SR 8/3/2007 17:09'!
resizeIfGreater
	self qualifier: self class qualifierResizeIfGreater! !

!SmagickGeometry methodsFor: 'accessing-dynamic' stamp: 'SR 8/3/2007 17:09'!
resizeIfSmaller
	self qualifier: self class qualifierResizeIfSmaller! !

!SmagickGeometry methodsFor: 'accessing' stamp: 'SR 8/3/2007 15:36'!
width
	^width ifNil: [ 0 ]! !

!SmagickGeometry methodsFor: 'accessing' stamp: 'SR 8/3/2007 15:32'!
width: anObject
	width := anObject! !

!SmagickGeometry methodsFor: 'accessing' stamp: 'SR 5/5/2008 17:53'!
width: anInteger height: anotherInteger
	self width: anInteger.
	self height: anotherInteger! !

!SmagickGeometry methodsFor: 'accessing' stamp: 'SR 8/3/2007 15:35'!
xoffset
	^xoffset ifNil: [ 0 ]! !

!SmagickGeometry methodsFor: 'accessing' stamp: 'SR 8/3/2007 15:32'!
xoffset: anObject
	xoffset := anObject! !

!SmagickGeometry methodsFor: 'accessing' stamp: 'SR 5/5/2008 17:53'!
xoffset: anInteger yoffset: anotherInteger
	self xoffset: anInteger.
	self yoffset: anotherInteger! !

!SmagickGeometry methodsFor: 'accessing' stamp: 'SR 2/13/2008 13:56'!
yoffset
	^ yoffset ifNil: [ 0 ]! !

!SmagickGeometry methodsFor: 'accessing' stamp: 'SR 8/3/2007 15:32'!
yoffset: anObject
	yoffset := anObject! !

Object subclass: #SmagickModule
	instanceVariableNames: 'format multiImage name nativeBlob read write'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Utils'!

!SmagickModule methodsFor: 'testing' stamp: 'SR 7/14/2007 16:44'!
canRead
	^ self read! !

!SmagickModule methodsFor: 'testing' stamp: 'SR 7/14/2007 16:44'!
canWrite
	^ self write! !

!SmagickModule methodsFor: 'accessing' stamp: 'SR 7/14/2007 16:43'!
format
	^ format! !

!SmagickModule methodsFor: 'accessing' stamp: 'SR 7/14/2007 16:43'!
format: anObject
	format := anObject! !

!SmagickModule methodsFor: 'testing' stamp: 'SR 7/15/2007 18:19'!
hasNativeBlob
	^ self nativeBlob! !

!SmagickModule methodsFor: 'testing' stamp: 'SR 8/5/2007 10:38'!
isMultiImage
	^ self multiImage! !

!SmagickModule methodsFor: 'testing' stamp: 'SR 7/14/2007 23:18'!
matches: aString
	^ (self name match: aString) 
		or: [ self format match: aString ]! !

!SmagickModule methodsFor: 'accessing' stamp: 'SR 8/5/2007 10:34'!
multiImage
	^multiImage! !

!SmagickModule methodsFor: 'accessing' stamp: 'SR 8/5/2007 10:34'!
multiImage: anObject
	multiImage := anObject! !

!SmagickModule methodsFor: 'private' stamp: 'SR 8/5/2007 10:44'!
multiImageSymbol
	^ self isMultiImage
		ifTrue: [ '+']
		ifFalse: [ '-' ]! !

!SmagickModule methodsFor: 'accessing' stamp: 'SR 7/14/2007 16:44'!
name
	^ name! !

!SmagickModule methodsFor: 'accessing' stamp: 'SR 7/14/2007 16:43'!
name: anObject
	name := anObject! !

!SmagickModule methodsFor: 'accessing' stamp: 'SR 7/14/2007 16:43'!
nativeBlob
	^ nativeBlob! !

!SmagickModule methodsFor: 'accessing' stamp: 'SR 7/14/2007 16:43'!
nativeBlob: anObject
	nativeBlob := anObject! !

!SmagickModule methodsFor: 'private' stamp: 'SR 8/5/2007 10:45'!
nativeBlobSymbol
	^ self nativeBlob
		ifTrue: [ '*' ]
		ifFalse: [ '' ]! !

!SmagickModule methodsFor: 'printing' stamp: 'SR 8/5/2007 10:45'!
printOn: aStream
	aStream 
		nextPutAll: format; space;
		nextPut: $[;
		nextPutAll: self readSymbol;
		nextPutAll: self writeSymbol;
		nextPutAll: self multiImageSymbol;
		nextPutAll: self nativeBlobSymbol.
	aStream nextPut: $]! !

!SmagickModule methodsFor: 'accessing' stamp: 'SR 7/14/2007 16:44'!
read
	^ read! !

!SmagickModule methodsFor: 'accessing' stamp: 'SR 7/14/2007 16:44'!
read: anObject
	read := anObject! !

!SmagickModule methodsFor: 'private' stamp: 'SR 7/14/2007 20:14'!
readSymbol
	^ self canRead
		ifTrue: [ 'r']
		ifFalse: [ '-' ]! !

!SmagickModule methodsFor: 'accessing' stamp: 'SR 7/14/2007 16:44'!
write
	^ write! !

!SmagickModule methodsFor: 'accessing' stamp: 'SR 7/14/2007 16:44'!
write: anObject
	write := anObject! !

!SmagickModule methodsFor: 'private' stamp: 'SR 7/14/2007 20:10'!
writeSymbol
	^ self canWrite
		ifTrue: [ 'w' ]
		ifFalse: [ '-' ]! !

Object subclass: #SmagickPrimitive
	instanceVariableNames: 'canvas flags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Drawing'!

SmagickPrimitive subclass: #SmagickCircle
	instanceVariableNames: 'center edge'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Drawing'!

!SmagickCircle class methodsFor: 'accessing' stamp: 'SR 8/12/2007 12:13'!
command
	^ #circle! !

!SmagickCircle methodsFor: 'private' stamp: 'SR 8/12/2007 10:43'!
appendPrimitiveTo: aStream
	self 
		quote: self class command 
		on: aStream 
		with: self center asArray
		with: self edge asArray! !

!SmagickCircle methodsFor: 'accessing' stamp: 'SR 8/12/2007 10:59'!
center
	^ center ifNil: [ self defaultPoint ]! !

!SmagickCircle methodsFor: 'accessing' stamp: 'SR 8/11/2007 20:02'!
center: anObject
	center := anObject! !

!SmagickCircle methodsFor: 'accessing' stamp: 'SR 8/12/2007 10:59'!
edge
	^ edge ifNil: [ self defaultPoint ]! !

!SmagickCircle methodsFor: 'accessing' stamp: 'SR 8/11/2007 20:08'!
edge: anObject
	edge := anObject! !

SmagickPrimitive subclass: #SmagickDrawImage
	instanceVariableNames: 'size position image mode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Drawing'!

!SmagickDrawImage class methodsFor: 'accessing' stamp: 'nl 1/16/2008 13:41'!
command
	^ #image! !

!SmagickDrawImage methodsFor: 'private' stamp: 'nl 1/16/2008 15:47'!
appendPrimitiveTo: aStream
	aStream
		nextPutAll: '''';
		nextPutAll: self class command ; 
		space;
		nextPutAll: self mode;
		space;
		nextPutAll: self position asCoordinate;
		nextPut: $,;
		nextPutAll: self size asCoordinate; 
		space;
		nextPut: $";
		nextPutAll: self image;
		nextPut: $";
		nextPutAll: ''''! !

!SmagickDrawImage methodsFor: 'private' stamp: 'nl 1/16/2008 11:54'!
defaultMode
	^ 'Over'! !

!SmagickDrawImage methodsFor: 'accessing' stamp: 'nl 1/16/2008 11:55'!
image
	^ image ! !

!SmagickDrawImage methodsFor: 'accessing' stamp: 'nl 1/16/2008 11:55'!
image: aFile
	image := aFile! !

!SmagickDrawImage methodsFor: 'accessing' stamp: 'nl 1/16/2008 11:56'!
mode
	^ mode ifNil: [ self defaultMode ]! !

!SmagickDrawImage methodsFor: 'accessing' stamp: 'nl 1/16/2008 11:56'!
mode: anObject
	mode := anObject! !

!SmagickDrawImage methodsFor: 'accessing' stamp: 'nl 1/16/2008 11:53'!
position
	^ position ifNil: [ self defaultPoint ]! !

!SmagickDrawImage methodsFor: 'accessing' stamp: 'nl 1/16/2008 11:54'!
position: aPoint
	position := aPoint! !

!SmagickDrawImage methodsFor: 'accessing' stamp: 'nl 1/16/2008 11:52'!
size
	^ size ifNil: [ self defaultPoint ]! !

!SmagickDrawImage methodsFor: 'accessing' stamp: 'nl 1/16/2008 11:53'!
size: aPoint
	size := aPoint! !

SmagickPrimitive subclass: #SmagickEllipse
	instanceVariableNames: 'arcStart arcStop center xRadius yRadius'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Drawing'!

!SmagickEllipse class methodsFor: 'accessing' stamp: 'SR 8/12/2007 11:40'!
command
	^ #ellipse! !

!SmagickEllipse methodsFor: 'private' stamp: 'SR 2/13/2008 13:56'!
appendPrimitiveTo: aStream
	self 
		quote: self class command 
		on: aStream 
		with: self center asArray
		with: { self xRadius. self yRadius }
		with: { self arcStart. self arcStop }! !

!SmagickEllipse methodsFor: 'accessing' stamp: 'SR 8/12/2007 11:40'!
arcStart
	^ arcStart ifNil: [ 0 ]! !

!SmagickEllipse methodsFor: 'accessing' stamp: 'SR 8/12/2007 11:38'!
arcStart: anObject
	arcStart := anObject! !

!SmagickEllipse methodsFor: 'accessing' stamp: 'SR 8/12/2007 11:40'!
arcStop
	^ arcStop ifNil: [ 360 ]! !

!SmagickEllipse methodsFor: 'accessing' stamp: 'SR 8/12/2007 11:39'!
arcStop: anObject
	arcStop := anObject! !

!SmagickEllipse methodsFor: 'accessing' stamp: 'SR 8/12/2007 11:40'!
center
	^ center ifNil: [ self defaultPoint]! !

!SmagickEllipse methodsFor: 'accessing' stamp: 'SR 8/12/2007 11:39'!
center: anObject
	center := anObject! !

!SmagickEllipse methodsFor: 'accessing' stamp: 'SR 8/12/2007 11:39'!
radius: anInteger
	self xRadius: anInteger.
	self yRadius: anInteger.! !

!SmagickEllipse methodsFor: 'accessing' stamp: 'SR 8/12/2007 11:39'!
xRadius
	^ xRadius ifNil: [ 0 ]! !

!SmagickEllipse methodsFor: 'accessing' stamp: 'SR 8/12/2007 11:39'!
xRadius: anObject
	xRadius := anObject! !

!SmagickEllipse methodsFor: 'accessing' stamp: 'SR 8/12/2007 11:40'!
yRadius
	^ yRadius ifNil: [ 0 ]! !

!SmagickEllipse methodsFor: 'accessing' stamp: 'SR 8/12/2007 11:39'!
yRadius: anObject
	yRadius := anObject! !

SmagickPrimitive subclass: #SmagickPoint
	instanceVariableNames: 'point'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Drawing'!

!SmagickPoint class methodsFor: 'accessing' stamp: 'SR 8/11/2007 20:23'!
command
	^ #point! !

!SmagickPoint methodsFor: 'private' stamp: 'SR 8/12/2007 10:44'!
appendPrimitiveTo: aStream
	self 
		quote: self class command 
		on: aStream 
		with: self point asArray! !

!SmagickPoint methodsFor: 'accessing' stamp: 'SR 8/12/2007 10:58'!
point
	^ point ifNil: [ self defaultPoint ]! !

!SmagickPoint methodsFor: 'accessing' stamp: 'SR 8/11/2007 20:23'!
point: anObject
	point := anObject! !

SmagickPrimitive subclass: #SmagickPolyline
	instanceVariableNames: 'points'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Drawing'!

SmagickPolyline subclass: #SmagickBezier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Drawing'!

!SmagickBezier class methodsFor: 'accessing' stamp: 'SR 8/12/2007 10:45'!
command
	^ #Bezier! !

SmagickPolyline subclass: #SmagickPolygon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Drawing'!

!SmagickPolygon class methodsFor: 'accessing' stamp: 'SR 8/12/2007 10:44'!
command
	^ #polygon! !

!SmagickPolyline class methodsFor: 'accessing' stamp: 'SR 8/12/2007 10:38'!
command
	^ #polyline! !

!SmagickPolyline methodsFor: 'image drawing' stamp: 'SR 8/12/2007 10:53'!
add: aPoint
	^ self points add: aPoint! !

!SmagickPolyline methodsFor: 'image drawing' stamp: 'SR 8/12/2007 10:54'!
add: aPoint after: anotherPoint
	^ self points add: aPoint after: anotherPoint! !

!SmagickPolyline methodsFor: 'image drawing' stamp: 'SR 8/12/2007 10:53'!
addFirst: aPoint
	^ self points addFirst: aPoint! !

!SmagickPolyline methodsFor: 'private' stamp: 'SR 8/12/2007 10:44'!
appendPrimitiveTo: aStream
	self 
		quote: self class command 
		on: aStream 
		withAll: self points asArray! !

!SmagickPolyline methodsFor: 'accessing' stamp: 'SR 8/12/2007 10:38'!
points
	^ points! !

!SmagickPolyline methodsFor: 'accessing' stamp: 'SR 8/12/2007 10:49'!
points: anObject
	points := anObject asOrderedCollection! !

!SmagickPolyline methodsFor: 'image drawing' stamp: 'SR 8/12/2007 10:53'!
remove: aPoint
	^ self points remove: aPoint ifAbsent: [  ]! !

!SmagickPolyline methodsFor: 'image drawing' stamp: 'SR 8/12/2007 10:49'!
removePoint: aPoint
	self points remove: aPoint ifAbsent: []! !

!SmagickPrimitive methodsFor: 'private' stamp: 'SR 8/11/2007 19:25'!
appendPrimitiveTo: aStream
	! !

!SmagickPrimitive methodsFor: 'private' stamp: 'SR 8/11/2007 19:27'!
appendTo: aStream
	aStream 
		nextPutAll: self flags contents; space;
		nextPutAll: '-draw'; space.
	self appendPrimitiveTo: aStream! !

!SmagickPrimitive methodsFor: 'private-formating' stamp: 'SR 8/11/2007 19:33'!
arrays: aCollection on: aStream
	aCollection 
		do: [ :array |
			array 
				do: [ :each | aStream nextPutAll: each asString ]
				separatedBy: [ aStream comma ] ]
		separatedBy: [ aStream space ]! !

!SmagickPrimitive methodsFor: 'accessing' stamp: 'SR 8/11/2007 18:43'!
canvas
	^ canvas! !

!SmagickPrimitive methodsFor: 'accessing' stamp: 'SR 8/11/2007 18:43'!
canvas: anObject
	canvas := anObject! !

!SmagickPrimitive methodsFor: 'private' stamp: 'SR 8/12/2007 10:59'!
defaultPoint
	^ 0 @ 0! !

!SmagickPrimitive methodsFor: 'private-accessing' stamp: 'SR 8/11/2007 18:52'!
emptyFlags
	^ ReadWriteStream with: String new! !

!SmagickPrimitive methodsFor: 'image drawing' stamp: 'SR 8/12/2007 11:10'!
fillColor: aColor
	self 
		put: '-fill'
		with: aColor! !

!SmagickPrimitive methodsFor: 'image drawing' stamp: 'SR 8/27/2007 10:30'!
fillTile: aTile 
	self fillTile: aTile withSize: self canvas extent! !

!SmagickPrimitive methodsFor: 'image drawing' stamp: 'SR 8/27/2007 10:31'!
fillTile: aTile withSize: anExtent
	self 
		put: '-size'
		with: anExtent asGeometry.
	self 
		put: '-tile'
		with: aTile asSmagickTile! !

!SmagickPrimitive methodsFor: 'private-accessing' stamp: 'SR 8/11/2007 19:27'!
flags
	^ flags ifNil: [ self resetFlags ]! !

!SmagickPrimitive methodsFor: 'image drawing' stamp: 'SR 8/12/2007 11:14'!
lineWidth: anInteger
	self strokeWidth: anInteger! !

!SmagickPrimitive methodsFor: 'private-formating' stamp: 'SR 8/11/2007 19:36'!
put: aString
	self flags space; nextPutAll: aString! !

!SmagickPrimitive methodsFor: 'private-formating' stamp: 'SR 8/11/2007 19:36'!
put: aCommand with: aValue
	self put: aCommand with: aValue postfix: ''! !

!SmagickPrimitive methodsFor: 'private-formating' stamp: 'SR 8/11/2007 19:36'!
put: aCommand with: aValue postfix: aString
	aValue isNil not ifTrue: [ 
		self put: aCommand asString;
			put: (aValue asString, aString) ]! !

!SmagickPrimitive methodsFor: 'private-formating' stamp: 'SR 8/12/2007 10:42'!
quote: aString on: aStream with: anArray
	self quote: aString on: aStream with: anArray with: nil! !

!SmagickPrimitive methodsFor: 'private-formating' stamp: 'SR 8/12/2007 10:42'!
quote: aString on: aStream with: anArray with: anotherArray
	self quote: aString on: aStream with: anArray with: anotherArray with: nil! !

!SmagickPrimitive methodsFor: 'private-formating' stamp: 'SR 8/12/2007 10:40'!
quote: aString on: aStream with: anArray with: anotherArray with: yetAnotherArray
	self 
		quote: aString 
		on: aStream 
		withAll: (Array with: anArray with: anotherArray with: yetAnotherArray)! !

!SmagickPrimitive methodsFor: 'private-formating' stamp: 'SR 8/12/2007 10:43'!
quote: aString on: aStream withAll: anArray
	aStream
		nextPutAll: '''';
		nextPutAll: aString; space.
	self arrays: (anArray select: [ :each | each isNil not ]) on: aStream.
	aStream nextPutAll: ''''! !

!SmagickPrimitive methodsFor: 'private-accessing' stamp: 'SR 8/11/2007 18:52'!
resetFlags
	^ flags := self emptyFlags! !

!SmagickPrimitive methodsFor: 'image drawing' stamp: 'SR 8/12/2007 11:10'!
strokeColor: aColor
	self 
		put: '-stroke'
		with: aColor! !

!SmagickPrimitive methodsFor: 'image drawing' stamp: 'SR 8/12/2007 11:10'!
strokeWidth: aColor
	self 
		put: '-strokewidth'
		with: aColor! !

SmagickPrimitive subclass: #SmagickRectangle
	instanceVariableNames: 'from to'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Drawing'!

SmagickRectangle subclass: #SmagickArc
	instanceVariableNames: 'arcStart arcStop'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Drawing'!

!SmagickArc class methodsFor: 'accessing' stamp: 'SR 8/12/2007 11:43'!
command
	^ #arc! !

!SmagickArc methodsFor: 'private' stamp: 'SR 8/12/2007 11:43'!
appendPrimitiveTo: aStream
	self 
		quote: self class command 
		on: aStream 
		with: self from asArray
		with:  self to asArray
		with: { self arcStart. self arcStop }! !

!SmagickArc methodsFor: 'accessing' stamp: 'SR 8/12/2007 11:44'!
arcStart
	^ arcStart ifNil: [ 0 ]! !

!SmagickArc methodsFor: 'accessing' stamp: 'SR 8/12/2007 11:43'!
arcStart: anObject
	arcStart := anObject! !

!SmagickArc methodsFor: 'accessing' stamp: 'SR 8/12/2007 11:44'!
arcStop
	^ arcStop ifNil: [ 360 ]! !

!SmagickArc methodsFor: 'accessing' stamp: 'SR 8/12/2007 11:43'!
arcStop: anObject
	arcStop := anObject! !

SmagickRectangle subclass: #SmagickLine
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Drawing'!

!SmagickLine class methodsFor: 'accessing' stamp: 'SR 8/11/2007 19:50'!
command
	^ #line! !

!SmagickRectangle class methodsFor: 'accessing' stamp: 'SR 8/11/2007 19:50'!
command
	^ #rectangle! !

!SmagickRectangle methodsFor: 'private' stamp: 'SR 8/12/2007 10:44'!
appendPrimitiveTo: aStream
	self 
		quote: self class command 
		on: aStream 
		with: self from asArray
		with: self to asArray! !

!SmagickRectangle methodsFor: 'accessing' stamp: 'SR 8/12/2007 10:59'!
from
	^ from ifNil: [ self defaultPoint ]! !

!SmagickRectangle methodsFor: 'accessing' stamp: 'SR 8/11/2007 18:42'!
from: anObject
	from := anObject! !

!SmagickRectangle methodsFor: 'accessing' stamp: 'SR 8/12/2007 10:59'!
to
	^ to ifNil: [ self defaultPoint ]! !

!SmagickRectangle methodsFor: 'accessing' stamp: 'SR 8/11/2007 18:42'!
to: anObject
	to := anObject! !

SmagickRectangle subclass: #SmagickRoundRectangle
	instanceVariableNames: 'cornerHeight cornerWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Drawing'!

!SmagickRoundRectangle class methodsFor: 'accessing' stamp: 'SR 8/12/2007 10:57'!
command
	^ #roundRectangle! !

!SmagickRoundRectangle methodsFor: 'private' stamp: 'SR 8/12/2007 10:58'!
appendPrimitiveTo: aStream
	self 
		quote: self class command 
		on: aStream 
		with: self from asArray
		with: self to asArray
		with: { self cornerWidth. self cornerHeight }! !

!SmagickRoundRectangle methodsFor: 'accessing' stamp: 'SR 8/12/2007 10:59'!
cornerHeight
	^ cornerHeight ifNil: [ 0 ]! !

!SmagickRoundRectangle methodsFor: 'accessing' stamp: 'SR 8/12/2007 10:57'!
cornerHeight: anObject
	cornerHeight := anObject! !

!SmagickRoundRectangle methodsFor: 'accessing' stamp: 'SR 8/12/2007 10:59'!
cornerWidth
	^ cornerWidth ifNil: [ 0 ]! !

!SmagickRoundRectangle methodsFor: 'accessing' stamp: 'SR 8/12/2007 10:57'!
cornerWidth: anObject
	cornerWidth := anObject! !

SmagickPrimitive subclass: #SmagickText
	instanceVariableNames: 'font size text geometry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Drawing'!

!SmagickText commentStamp: 'SR 9/1/2007 13:30' prior: 0!
xOffset / yOffset = lower left point of the text!

!SmagickText methodsFor: 'private' stamp: 'SR 8/26/2007 17:30'!
appendPrimitiveTo: aStream
	aStream 
		nextPutAll: '-font'; space;
		nextPutAll: self font asString doubleQuoted ; space;
		nextPutAll: '-pointsize'; space;
		nextPutAll: self size asString ; space;
		nextPutAll: '-annotate'; space.
	self geometry printOn: aStream.
	aStream 
		space; 
		nextPutAll: self text asString doubleQuoted! !

!SmagickText methodsFor: 'private' stamp: 'SR 8/26/2007 16:23'!
appendTo: aStream
	aStream nextPutAll: self flags contents; space.
	self appendPrimitiveTo: aStream! !

!SmagickText methodsFor: 'accessing' stamp: 'SR 9/1/2007 13:25'!
at: aPoint
	self geometry xOffset: aPoint x; yOffset: aPoint y! !

!SmagickText methodsFor: 'accessing' stamp: 'SR 8/26/2007 15:18'!
font
	^ font! !

!SmagickText methodsFor: 'accessing' stamp: 'SR 8/26/2007 15:18'!
font: aFont
	font := aFont! !

!SmagickText methodsFor: 'accessing' stamp: 'SR 9/1/2007 13:20'!
geometry
	^ geometry ifNil: [ geometry := SmagickRotation new ]! !

!SmagickText methodsFor: 'accessing' stamp: 'SR 9/1/2007 13:21'!
geometry: aSmagickRotationGeometry
	geometry := aSmagickRotationGeometry ! !

!SmagickText methodsFor: 'accessing' stamp: 'SR 8/26/2007 15:18'!
size
	^ size! !

!SmagickText methodsFor: 'accessing' stamp: 'SR 8/26/2007 15:18'!
size: anInteger
	size := anInteger! !

!SmagickText methodsFor: 'accessing' stamp: 'SR 8/26/2007 15:16'!
text
	^ text! !

!SmagickText methodsFor: 'accessing' stamp: 'SR 8/26/2007 15:16'!
text: aString
	text := aString! !

!SmagickText methodsFor: 'accessing' stamp: 'SR 9/1/2007 13:21'!
xOffset
	^ self geometry xOffset! !

!SmagickText methodsFor: 'accessing' stamp: 'SR 9/1/2007 13:22'!
xOffset: anObject
	self geometry xOffset: anObject! !

!SmagickText methodsFor: 'accessing' stamp: 'SR 9/1/2007 13:21'!
xRotation
	^ self geometry xRotation! !

!SmagickText methodsFor: 'accessing' stamp: 'SR 9/1/2007 13:22'!
xRotation: anObject
	self geometry xRotation: anObject! !

!SmagickText methodsFor: 'accessing' stamp: 'SR 9/1/2007 13:21'!
yOffset
	^self geometry yOffset! !

!SmagickText methodsFor: 'accessing' stamp: 'SR 9/1/2007 13:22'!
yOffset: anObject
	self geometry yOffset: anObject! !

!SmagickText methodsFor: 'accessing' stamp: 'SR 9/1/2007 13:21'!
yRotation
	^self geometry yRotation! !

!SmagickText methodsFor: 'accessing' stamp: 'SR 9/1/2007 13:22'!
yRotation: anObject
	self geometry yRotation: anObject! !

Object subclass: #SmagickRotation
	instanceVariableNames: 'xRotation yRotation xOffset yOffset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Utils'!

!SmagickRotation methodsFor: 'testing' stamp: 'SR 8/26/2007 15:35'!
= anObject
	^ self species = anObject species
		and: [ self xRotation  = anObject xRotation 
			and: [ self yRotation  = anObject yRotation 
				and: [ self xoffset  = anObject xoffset 
					and: [ self yoffset = anObject yoffset ] ] ] ]! !

!SmagickRotation methodsFor: 'priting' stamp: 'SR 8/26/2007 16:16'!
printOn: aStream
	aStream 
		nextPutAll: self xRotation asString; 
		nextPut: $x;
		nextPutAll: self yRotation asString;
		nextPut: (self xOffset >= 0 ifTrue: [ $+ ] ifFalse: [ $- ]);
		nextPutAll: self xOffset abs asString;
		nextPut: (self yOffset >= 0 ifTrue: [ $+ ] ifFalse: [ $- ]);
		nextPutAll: self yOffset abs asString! !

!SmagickRotation methodsFor: 'accessing' stamp: 'SR 8/26/2007 15:34'!
xOffset
	^ xOffset ifNil: [ 0 ]! !

!SmagickRotation methodsFor: 'accessing' stamp: 'SR 8/26/2007 15:33'!
xOffset: anInteger
	xOffset := anInteger! !

!SmagickRotation methodsFor: 'accessing' stamp: 'SR 8/26/2007 15:34'!
xRotation
	^ xRotation ifNil: [ 0 ]! !

!SmagickRotation methodsFor: 'accessing' stamp: 'SR 8/26/2007 15:33'!
xRotation: aFloat
	xRotation := aFloat! !

!SmagickRotation methodsFor: 'accessing' stamp: 'SR 8/26/2007 15:34'!
yOffset
	^ yOffset ifNil: [ 0 ]! !

!SmagickRotation methodsFor: 'accessing' stamp: 'SR 8/26/2007 15:33'!
yOffset: anInteger
	yOffset := anInteger! !

!SmagickRotation methodsFor: 'accessing' stamp: 'SR 8/26/2007 15:34'!
yRotation
	^ yRotation ifNil: [ 0 ]! !

!SmagickRotation methodsFor: 'accessing' stamp: 'SR 8/26/2007 15:33'!
yRotation: aFloat
	yRotation := aFloat! !

!UndefinedObject methodsFor: '*Smagick' stamp: 'SR 6/30/2007 17:43'!
@ anObject
	^ Point x: self y: anObject! !

!Character class methodsFor: '*Smagick' stamp: 'SR 7/12/2007 22:12'!
comma
	^ $,! !

!Character class methodsFor: '*Smagick' stamp: 'SR 8/25/2007 12:37'!
semicolon
	^ $;! !

Error subclass: #SmagickException
	instanceVariableNames: 'processor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Utils'!

SmagickException subclass: #SmagickCompositionFailed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Utils'!

SmagickException subclass: #SmagickConvertFailed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Utils'!

SmagickException subclass: #SmagickEnvironmentNotInitialized
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Utils'!

!SmagickEnvironmentNotInitialized methodsFor: 'as yet unclassified' stamp: 'SR 7/15/2007 18:57'!
signal
	self messageText: 'run SmagickEnvironment>>setup first'.
	super signal.! !

!SmagickException class methodsFor: 'signaling' stamp: 'SR 9/9/2007 12:58'!
signalWith: aProcessor
	^ self new 
		processor: aProcessor; 
		signal! !

!SmagickException methodsFor: 'accessing' stamp: 'SR 9/9/2007 12:39'!
processor
	^processor! !

!SmagickException methodsFor: 'accessing' stamp: 'SR 9/9/2007 12:39'!
processor: anObject
	processor := anObject! !

SmagickException subclass: #SmagickFileDoesNotExist
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Utils'!

SmagickException subclass: #SmagickIdentifyFailed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Utils'!

SmagickException subclass: #SmagickInvalidGeometry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Utils'!

SmagickException subclass: #SmagickTransformationException
	instanceVariableNames: 'transformation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Utils'!

SmagickTransformationException subclass: #SmagickInsufficientDataException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Utils'!

!SmagickTransformationException class methodsFor: 'signaling' stamp: 'SR 9/9/2007 12:58'!
signalFor: aTransformation with: aProcessor
	^ self new 
		transformation: aTransformation;
		processor: aProcessor; 
		signal! !

!SmagickTransformationException methodsFor: 'printing' stamp: 'SR 5/7/2008 13:00'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' (',self transformation asString, ')'! !

!SmagickTransformationException methodsFor: 'accessing' stamp: 'SR 9/9/2007 12:56'!
transformation
	^transformation! !

!SmagickTransformationException methodsFor: 'accessing' stamp: 'SR 9/9/2007 12:56'!
transformation: anObject
	transformation := anObject! !

SmagickTransformationException subclass: #SmagickUnrecognizedOption
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smagick-Utils'!
